{*********************************************}
{*   RepoEdit -  QuickReport Editor          *}
{*   for Delphi 4                            *}
{*   (R) Copyright                           *}
{*   Borzov Vladimir borzov@rsm.ru           *}
{*********************************************}
unit EditFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Buttons, ExtCtrls,
  QuickRPT,QRCTRLS,QRPRNTR,
  printers, ExtDlgs,RepoEdit,jpeg,ConfirmUnit1;

type
  TEditForm = class(TForm)
    EditTransparent: TCheckBox;
    EditWordWrap: TCheckBox;
    EditAutoSize: TCheckBox;
    EditStretch: TCheckBox;
    EditEnabled: TCheckBox;
    EditFont: TBitBtn;
    FontDialog: TFontDialog;
    ColorDialog: TColorDialog;
    EditColor: TBitBtn;
    EditFrame: TBitBtn;
    EditLeft: TSpinEdit;
    EditTop: TSpinEdit;
    EditWidth: TSpinEdit;
    EditHeight: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    EditNotFrontBack: TRadioGroup;
    EditLines: TBitBtn;
    EditPicture: TBitBtn;
    BitBtnOk: TBitBtn;
    BitBtnCancel: TBitBtn;
    EditCenter: TCheckBox;
    EditBrush: TBitBtn;
    EditPen: TBitBtn;
    EditDATA: TComboBox;
    Bevel1: TBevel;
    EditPage: TBitBtn;
    EditZoom: TSpinEdit;
    LabZOOM: TLabel;
    EditPrintIfEmpty: TCheckBox;
    EditPrinter: TBitBtn;
    EditBandType: TComboBox;
    EditForceNewColumn: TCheckBox;
    EditForceNewPage: TCheckBox;
    LabAlignment: TLabel;
    EditAlignMent: TComboBox;
    EditAlignToBottom: TCheckBox;
    LabBandType: TLabel;
    LabMask: TLabel;
    EditMask: TEdit;
    OpenPictureDialog: TOpenPictureDialog;
    OpenDialog: TOpenDialog;
    BitBtnDefault: TBitBtn;
    EditCaption: TComboBox;
    CheckReset: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EditFontClick(Sender: TObject);
    procedure EditFrameClick(Sender: TObject);
    procedure EditBrushClick(Sender: TObject);
    procedure EditPenClick(Sender: TObject);
    procedure EditColorClick(Sender: TObject);
    procedure EditPrinterClick(Sender: TObject);
    procedure EditPageClick(Sender: TObject);
    procedure EditPictureClick(Sender: TObject);
    procedure EditLinesClick(Sender: TObject);
    procedure BitBtnDefaultClick(Sender: TObject);
    procedure BitBtnCancelClick(Sender: TObject);
  private
    { Private declarations }
    ThFrame:TQRFrame;
    ThBrush:TBrush;
    ThPen:TPen;
    ThPrinterSettings:TQuickRepPrinterSettings;
    ThPage:TQRpage;
  public
    { Public declarations }
    ThComp:TComponent;
    ThRepEdit:TRepoEdit;
    procedure SaveCompProp;
  end;

var
  EditForm: TEditForm;

implementation

uses FrameEditUnit,EditBrushUnit, EditPenUnit,
  PrinterSettingsUnit, EditPageUnit, EditShapeUnit,DB, MessUnit,
  qrExpbld,GEtMemoTextUnit;

{$R *.DFM}

procedure TEditForm.FormCreate(Sender: TObject);
begin
  ThComp:=nil;
  ThFrame:=nil;
  ThBrush:=nil;
  ThPen:=nil;
  ThPrinterSettings:=nil;
  ThPage:=nil;
  ThRepEdit:=nil;
end;


procedure TEditForm.BitBtnOkClick(Sender: TObject);
begin
  Close;
  SaveCompProp;
end;

procedure TEditForm.SaveCompProp;
var i:integer;
begin

  if Not Assigned(ThComp) then begin
    bvMessError('Cannot define type of object!');
    exit;
  end;

  if (ThComp is TQuickRep)
  then    ThRepEdit.enabled:=EditEnabled.Checked
  else    (ThComp as TCustomControl).Enabled:=EditEnabled.Checked;


  for i:=0 to (ThComp as TCustomControl).ControlCount-1 do
    if (ThComp as TCustomControl).Controls[i] is tEnabledLab then begin
       (ThComp as TCustomControl).Controls[i].Visible:=not (ThComp as TCustomControl).Enabled;
       break
    end;

  (ThComp as TCustomControl).Top:=EditTop.Value;
  (ThComp as TCustomControl).Width:=EditWidth.Value;
  (ThComp as TCustomControl).Left:=EditLeft.Value;
  (ThComp as TCustomControl).Height:=EditHeight.Value;


  if EditNotFrontBack.ItemIndex=1 then begin
     (ThComp as TCustomControl).BringToFront;
     if (ThComp.Owner is TRepoEdit) then
       (ThComp.Owner as TRepoEdit).SaveNotFrontBack(thcomp.Name,editNotFrontBack.ItemIndex);
  end
  else if EditNotFrontBack.ItemIndex=2 then begin
     (ThComp as TCustomControl).SendToBack;
     if (ThComp.Owner is TRepoEdit) then
       (ThComp.Owner as TRepoEdit).SaveNotFrontBack(ThComp.Name,editNotFrontBack.ItemIndex);
  end;

  if ThComp is TGraphicControl then begin
      (ThComp as TGraphicControl).Left:=EditLeft.Value;
      (ThComp as TGraphicControl).Top:=EditTop.Value;
      (ThComp as TGraphicControl).Width:=EditWidth.Value;
      (ThComp as TGraphicControl).height:=EditHeight.Value;
      if EditNotFrontBack.ItemIndex=1 then begin
         (ThComp as TGraphicControl).BringToFront;
      end
      else if EditNotFrontBack.ItemIndex=2 then begin
         (ThComp as TGraphicControl).SendToBack;
      end;
  end;

  if thcomp is TQRCustomLabel then (thcomp as TQRCustomLabel).Font:=FontDialog.Font
  else if thcomp is TQRCustomRichText then (thcomp as TQRCustomRichText).Font:=FontDialog.Font
  else if thcomp is TQRCustomBand then   (thcomp as TQRCustomBand).Font:=FontDialog.Font
  else if thcomp is TQuickRep then   (thcomp as TQuickRep).Font:=FontDialog.Font;

//  if ThComp is TEditLabel then (ThComp as TEditLabel).Font:=FontDialog.Font;


  if thcomp is TQRCustomLabel
  then  (thcomp as TQRCustomLabel).WordWrap:=EditWordWrap.Checked;

  if (thcomp is TQRCustomLabel) then  (thcomp as TQRCustomLabel).AutoSize:=EditAutoSize.Checked
  else if (thcomp is TQRImage) then  (thcomp as TQRImage).AutoSize:=EditAutoSize.Checked;

  if (thcomp is TQRCustomLabel) then (thcomp as TQRCustomLabel).AutoStretch:=EditStretch.Checked
  else if (thcomp is TQRImage) then (thcomp as TQRImage).Stretch:=EditStretch.Checked
  else if (thcomp is TQRDBImage) then (thcomp as TQRDBImage).Stretch:=EditStretch.Checked
  else if (thcomp is TQRCustomRichText) then (thcomp as TQRCustomRichText).AutoStretch:=EditStretch.Checked;

  if (thcomp is TQRLabel) then  (thcomp as TQRLabel).Transparent:=EditTransparent.Checked
  else if (thcomp is TQRDBText) then  (thcomp as TQRDBText).Transparent:=EditTransparent.Checked
  else if (thcomp is TQRMemo) then  (thcomp as TQRMemo).Transparent:=EditTransparent.Checked
  else if (thcomp is TQRExpr) then  (thcomp as TQRExpr).Transparent:=EditTransparent.Checked
  else if (thcomp is TQRSysData) then  (thcomp as TQRSysData).Transparent:=EditTransparent.Checked;

//  if ThComp is TEditlabel then (ThComp as TEditLabel).Transparent:=EditTransparent.Checked
//  else if ThComp is TImage then (ThComp as TImage).Transparent:=EditTransparent.Checked;

  if thcomp is TQRCustomLabel then  (thcomp as TQRCustomLabel).Alignment:=TAlignment(EditAlignMent.ItemIndex)
  else if thcomp is TQRCustomRichText then (thcomp as TQRCustomRichText).Alignment:=TAlignment(EditAlignMent.ItemIndex);

//  if ThComp is TEditLabel then  (THComp as TEditLabel).Alignment:=TAlignment(EditAlignMent.ItemIndex);

  if thcomp is TQuickRep then (thcomp as TQuickRep).PrintIfEmpty:=EditPrintIfEmpty.Checked;

  if thcomp is TQRCustomBand then (thcomp as TQrCustomBand).BandType:=TQRBandType(EditBandType.ItemIndex);

  if thcomp is TQRCustomBand then begin
    (thcomp as TQRCustomband).AlignToBottom:=EditAlignToBottom.Checked;
    (thcomp as TQRCustomband).ForceNewColumn:=EditForceNewColumn.Checked;
    (thcomp as TQRCustomband).ForceNewpage:=EditForceNewPage.Checked;
  end;

  if thcomp is TQRDBText then (thcomp as TQRDBText).DataField:=EditCaption.Text
  else if thcomp is TQREXPr then begin
    (thcomp as TQREXPR).Expression:=EditCaption.Text;
    (thcomp as TQrExpr).ResetAfterPrint:=CheckReset.Checked;
  end
  else
   if thcomp is TQRDBImage then (thcomp as TQRDBImage).DataField:=EditCaption.Text
  else if thcomp is TQRSysData then (thcomp as TQRsysdata).Text:=EditCaption.Text
  else if thcomp is TQRCustomLabel then (thcomp as TQRCustomlabel).Caption:=EditCaption.Text;
//  if ThComp is TEditlabel then (ThComp as TEditLabel).caption:=EditCaption.Text;


  if thcomp is TQRDBText then (thcomp as TQRDBText).Mask:=EditMask.Text
  else if thcomp is TQRExpr then (thcomp as TQrExpr).Mask:=EditMask.Text;

  if thcomp is TQRImage then (thcomp as TQRImage).Center:=EditCenter.Checked
  else if thcomp is TQRDBImage then (thcomp as TQRDBImage).Center:=EditCenter.Checked;

  if thcomp is TQRSysData then (thcomp as TQRSysData).Data:=TQRSysDATAType(EditDATA.ItemIndex);


  if thcomp is TQRCustomLabel then (thcomp as TQRCustomLabel).Color:=ColorDialog.Color
  else if thcomp is TQRCustomRichText then (thcomp as TQRCustomRichText).Color:=ColorDialog.Color
  else if thcomp is TQRCustomBand then (thcomp as TQRCustomBand).Color:=ColorDialog.Color;



  if (thcomp is TQRPrintable) then ThFrame:=(thcomp as TQRPrintable).Frame
  else if (thcomp is TQRBasePanel) then ThFrame:=(thcomp as TQRBasePanel).Frame;

  if thcomp is TQRPrintable then (thcomp as TQRPrintable).Zoom:=EditZoom.Value
  else if thcomp is TQRBasePanel then (thcomp as TQRBasepanel).Zoom:=EditZOOM.Value;

  if ThComp is TGraphicControl then
     (ThComp as TGraphicControl).Repaint;

  if Assigned(thRepEdit)
  then begin
    thRepEdit.SetRectCoord;
    if  assigned(thRepEdit.thPanel) then begin
      thRepEdit.thPanel.SetFontButtons;
    end
  end;

end;

procedure TEditForm.FormShow(Sender: TObject);
var //thcomp:TComponent;
//    ThNotFrontBack:integer;
    i,k:integer;
    ThDataSet:TDataSet;
begin
  if Not Assigned(thcomp) then begin
    bvMessError('Cannot define type of object!');
    exit;
  end;

  self.Caption:='Component editor: ('+thComp.Name+')';

  if (thcomp is TQuickRep)
  then   EditEnabled.Checked:=thRepEdit.Enabled
  else   EditEnabled.Checked:=(thcomp as TCustomControl).Enabled;

  EditTop.Value:=(thcomp as TCustomControl).Top;
  EditWidth.Value:=(thcomp as TCustomControl).Width;
  EditLeft.Value:=(thcomp as TCustomControl).Left;
  EditHeight.Value:=(thcomp as TCustomControl).Height;
  ThBrush:=(thcomp as TCustomControl).Brush;

  if thcomp is TQRShape then ThPen:=(thcomp as TQRShape).pen
  else EditPen.Enabled:=false;

  if thcomp is TQuickRep then begin
     ThPrinterSettings:=(thcomp as TQuickRep).PrinterSettings;
     thPage:=(thcomp as TQuickRep).Page;
  end
  else begin
     EditPrinter.Enabled:=false;
     EditPage.Enabled:=false;
  end;

//  if (thcomp is
  if thcomp is TQRCustomLabel then  EditWordWrap.Checked:= (thcomp as TQRCustomLabel).WordWrap
  else EditWordWrap.Enabled:=false;

  if (thcomp is TQRCustomLabel) then  EditAutoSize.Checked:=(thcomp as TQRCustomLabel).AutoSize
  else if (thcomp is TQRImage) then  EditAutoSize.Checked:=(thcomp as TQRImage).AutoSize
  else EditAutoSize.Enabled:=false;

  if (thcomp is TQRCustomLabel) then EditStretch.Checked:=(thcomp as TQRCustomLabel).AutoStretch
  else if (thcomp is TQRImage) then EditStretch.Checked:=(thcomp as TQRImage).Stretch
  else if (thcomp is TQRDBImage) then EditStretch.Checked:=(thcomp as TQRDBImage).Stretch
  else if (thcomp is TQRCustomRichText) then EditStretch.Checked:=(thcomp as TQRCustomRichText).AutoStretch
  else EditStretch.Enabled:=false;

  if (thcomp is TQRLabel) then  EditTransparent.Checked:=(thcomp as TQRLabel).Transparent
  else if (thcomp is TQRDBText) then  EditTransparent.Checked:=(thcomp as TQRDBText).Transparent
  else if (thcomp is TQRMemo) then  EditTransparent.Checked:=(thcomp as TQRMemo).Transparent
  else if (thcomp is TQRExpr) then  EditTransparent.Checked:=(thcomp as TQRExpr).Transparent
  else if (thcomp is TQRSysData) then  EditTransparent.Checked:=(thcomp as TQRSysData).Transparent
  else EditTransparent.Enabled:=false;


  if thcomp is TQRCustomLabel then EditAlignMent.ItemIndex:=
     ORD((thcomp as TQRCustomLabel).Alignment)
  else if thcomp is TQRCustomRichText then EditAlignMent.ItemIndex:=
     ORD((thcomp as TQRCustomRichText).Alignment)
  else begin
    EditAlignMent.Enabled:=false;
    LabAlignment.Enabled:=false;
  end;


  if thcomp is TQuickRep then EditPrintIfEmpty.Checked:=(thcomp as TQuickRep).PrintIfEmpty
  else EditPrintIfEmpty.Enabled:=false;

  if thcomp is TQRCustomBand then EditBandType.ItemIndex:=
     ORD((thcomp as TQrCustomBand).BandType)
  else begin
    EditBandType.Enabled:=false;
    LabBandType.Enabled:=false;
  end;

  if thcomp is TQRCustomBand then begin
    EditAlignToBottom.Checked:=(thcomp as TQRCustomband).AlignToBottom;
    EditForceNewColumn.Checked:=(thcomp as TQRCustomband).ForceNewColumn;
    EditForceNewPage.Checked:=(thcomp as TQRCustomband).ForceNewpage;
  end
  else begin
    EditAlignToBottom.Enabled:=false;
    EditForceNewColumn.Enabled:=false;
    EditForceNewPage.Enabled:=false;
  end;

  if thcomp is TQRDBText then begin
    EditCaption.Style:=csDropDown;
    EditCaption.Items.Clear;
    for i:=0 to thcomp.Owner.ComponentCount-1 do
      if (thcomp.Owner.components[i] is TDataSet) then begin
         ThDataSet:=TDataSet(thcomp.Owner.components[i]);
         for k:=0 to ThDataSet.FieldCount-1 do begin
           EditCaption.Items.Add(ThDataSet.Fields[k].FieldName);
         end;
      end;
    EditCaption.Text:=(thcomp as TQRDBText).DataField;
  end
  else
  if thcomp is TQRDBImage then begin
    EditCaption.Style:=csDropDown;
    EditCaption.Items.Clear;
    for i:=0 to thcomp.Owner.ComponentCount-1 do
      if (thcomp.Owner.components[i] is TDataSet) then begin
         ThDataSet:=TDataSet(thcomp.Owner.components[i]);
         for k:=0 to ThDataSet.FieldCount-1 do begin
           EditCaption.Items.Add(ThDataSet.Fields[k].FieldName);
         end;
      end;
    EditCaption.Text:=(thcomp as TQRDBImage).DataField;
  end
  else
  if thcomp is TQREXPR then EditCaption.Text:=(thcomp as TQREXPR).Expression
  else
  if thcomp is TQRSysData then EditCaption.Text:=(thcomp as TQRsysdata).Text
  else
  if thcomp is TQRCustomLabel then EditCaption.Text:=(thcomp as TQRCustomlabel).Caption
  else begin
     EditCaption.Enabled:=false;
     if not (thcomp is TQRRichText) then EditLines.Enabled:=false;
  end;

  if thcomp is TQRDBText then EditMask.Text:=(thcomp as TQRDBText).Mask
  else if thcomp is TQRExpr then EditMask.Text:=(thcomp as TQrExpr).Mask
  else begin
     EditMask.Enabled:=false;
     LabMask.Enabled:=false;
  end;

  if thcomp is TqrExpr then CheckReset.Checked:=(thcomp as TqrExpr).ResetAfterPrint
  else begin
     CheckReset.Enabled:=false;
  end;

  if thcomp is TQRImage then EditCenter.Checked:=(thcomp as TQRImage).Center
  else if thcomp is TQRDBImage then EditCenter.Checked:=(thcomp as TQRDBImage).Center
  else begin
    EditCenter.Enabled:=false;
    if not (thcomp is TQRShape) then  EditPicture.Enabled:=false;
  end;

  if thcomp is TQRSysData then EditDATA.ItemIndex:=ord((thcomp as TQRSysData).Data)
  else EditDATA.Enabled:=false;

  if thcomp is TQRCustomLabel then FontDialog.Font:=(thcomp as TQRCustomLabel).Font
  else if thcomp is TQRCustomRichText then FontDialog.Font:=(thcomp as TQRCustomRichText).Font
  else if thcomp is TQRCustomBand then   FontDialog.Font:=(thcomp as TQRCustomBand).Font
  else if thcomp is TQuickRep then   FontDialog.Font:=(thcomp as TQuickRep).Font
  else EditFont.Enabled:=false;


  if thcomp is TQRCustomLabel then ColorDialog.Color:= (thcomp as TQRCustomLabel).Color
  else if thcomp is TQRCustomRichText then ColorDialog.Color:= (thcomp as TQRCustomRichText).Color
  else if thcomp is TQRCustomBand then ColorDialog.Color:= (thcomp as TQRCustomBand).Color
  else EditColor.Enabled:=false;

  if (thcomp is TQRPrintable) then ThFrame:=(thcomp as TQRPrintable).Frame
  else if (thcomp is TQRBasePanel) then ThFrame:=(thcomp as TQRBasePanel).Frame
  else EditFrame.Enabled:=false;

  if thcomp is TQRPrintable then EditZoom.Value:=(thcomp as TQRPrintable).Zoom
  else if thcomp is TQRBasePanel then EditZOOM.Value:=(thcomp as TQRBasepanel).Zoom
  else begin
    EditZOOM.Enabled:=false;
    LabZOOM.enabled:=false;
  end;


  if thcomp is TQRBasePanel then begin
    EditNotFrontBack.Enabled:=false;
  end
  else if (ThComp.Owner is TRepoEdit) then begin
    EditNotFrontBack.ItemIndex:=(ThComp.Owner as TRepoEdit).RestoreNotFrontBack(thcomp.Name);
  end;

end;

procedure TEditForm.EditFontClick(Sender: TObject);
begin
  FontDialog.Execute;
end;

procedure TEditForm.EditFrameClick(Sender: TObject);
var FrEd:TFrameEditForm;
begin
   FrEd:=TFrameEditForm.Create(Self);
   FrEd.ThFrame:=ThFrame;
   FrEd.ShowModal;
   FrEd.Free;
end;

procedure TEditForm.EditBrushClick(Sender: TObject);
var EdBr:TEditBrushForm;
begin
  EdBr:=TEditBrushForm.Create(Self);
  EdBR.ThBrush:=ThBrush;
  EdBr.ShowModal;
  EdBr.Free;
end;

procedure TEditForm.EditPenClick(Sender: TObject);
var EdPen:TEditPenForm;
begin
  EdPen:=TEditPenForm.Create(Self);
  EdPen.ThPen:=ThPen;
  Edpen.ShowModal;
  EdPen.Free;
end;

procedure TEditForm.EditColorClick(Sender: TObject);
begin
  ColorDialog.Execute;
end;

procedure TEditForm.EditPrinterClick(Sender: TObject);
var ThF:TPrinterSettingsForm;
begin
  ThF:=TPrinterSettingsForm.Create(Application);
  ThF.ThprinterSettings:=ThPrinterSettings;
  ThF.ShowModal;
  ThF.Free;
end;

procedure TEditForm.EditPageClick(Sender: TObject);
var EdP:TEditPageForm;
begin
  EdP:=TEditPageForm.Create(Application);
  Edp.thPage:=ThPage;
  Edp.Showmodal;
  EdP.Free;
end;

procedure TEditForm.EditPictureClick(Sender: TObject);
var ShF:TEditShapeForm;
begin
  if ThComp is TQRShape then begin
    ShF:=TEditShapeForm.Create(Application);
    ShF.EditShapeType.itemIndex:=ord((ThComp as TQRShape).Shape);
    ShF.SetImage;
    if ShF.ShowModal=mrOk then (ThComp as TQRShape).Shape:=
       TQRShapeType(ShF.EditShapeType.ItemIndex);
    ShF.Free;
  end
  else if ThComp is TQRImage then begin

    OpenPictureDialog.FileName:=(ThComp.Owner as TRepoEdit).GetDopParam(ThComp,'PICTURE');

    if (OpenPictureDialog.Execute) then begin

//     (ThComp.Owner as TRepoEdit).SaveFileName((ThComp as TEditlabel).OBJ,OpenPictureDialog.FileName);
    (ThComp.Owner as TRepoEdit).SetDopParam(ThComp,'PICTURE',OpenPictureDialog.FileName);

     try
       (ThComp as TQRImage).Picture.LoadFromFile(OpenPictureDialog.FileName);
     except
       on e:exception do bvMessError('Cannot open file'+#13+
                  'Message:'+E.Message);
     end;
    end;
  end;
end;

procedure TEditForm.EditLinesClick(Sender: TObject);
var str:string;
begin
  if (ThComp is TQRRichText) or (ThComp is TQRMemo) then begin

    OpenDialog.FileName:=(ThComp.Owner as TRepoEdit).GetDopParam(ThComp,'LINES');

    if (OpenDialog.Execute) then begin
     (ThComp.Owner as TRepoEdit).SetDopParam(ThComp,'LINES',OpenDialog.FileName);
     try
      if (ThComp is TQRRichText)
         then (ThComp as TQRRichText).Lines.LoadFromFile(OpenDialog.FileName)
      else (ThComp as TQRMemo).Lines.LoadFromFile(OpenDialog.FileName);
     except
       on e:exception do bvMessError('Cannot open file'+#13+
                  'Message:'+E.Message);
     end;
    end;
  end
  else if thComp is TQRExpr then begin
    str:=editcaption.text;
    GetExpression( 'Input expression',str,nil,nil,nil);
    editcaption.text:=str;
  end
  else if thComp is TQRExpr then begin
    str:=editcaption.text;
    GetExpression( ' ',str,nil,nil,nil);
    editcaption.text:=str;
  end
  else if thComp is tqrCustomLabel then
  with tGetmemoTextForm.Create(application) do
  try
    Memo.Text:=Self.EditCaption.Text;
    if ShowModal=mrOk then Self.EditCaption.Text:=Memo.Text;
  finally
     free;
  end;
end;

procedure TEditForm.BitBtnDefaultClick(Sender: TObject);
begin
  if Assigned(thComp) and  (GetConfirmSmall('You want to restore parameters by default?')=mrOk)
  then begin
    if ThComp is TQuickRep then  begin
      ThRepEdit.DeleteSavedReport(False);
      bvMess('After rebooting an editor check correctness executed to operations');
      self.Close;
      ThRepEdit.ThForm.Close;
      exit;
    end
    else begin
      (ThComp.owner as TRepoEdit).DeleteSaved(ThComp.Name);
      bvMess('Changes take effect only after rebooting an editor');
      self.Close;
      (ThComp.Owner as TRepoEdit).ThForm.Close;
    end
  end;

end;

procedure TEditForm.BitBtnCancelClick(Sender: TObject);
begin
  Close;
end;

end.
