{*********************************************}
{*   RepoEdit -  QuickReport Editor          *}
{*   for Delphi 4                            *}
{*   (R) Copyright                           *}
{*   Borzov Vladimir borzov@rsm.ru           *}
{*********************************************}
unit FrameEditUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  QuickRPT,QRCTRLS,QRPRNTR,
  StdCtrls, Buttons, Spin;

type
  TFrameEditForm = class(TForm)
    BitBtnColor: TBitBtn;
    ColorDialog: TColorDialog;
    EditTop: TCheckBox;
    EditBottom: TCheckBox;
    EditLeft: TCheckBox;
    EditRight: TCheckBox;
    EditWidth: TSpinEdit;
    EditStyle: TComboBox;
    BitBtnOk: TBitBtn;
    BitBtnCANCEL: TBitBtn;
    procedure BitBtnColorClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ThFrame:TQRFrame;
  end;

var
  FrameEditForm: TFrameEditForm;

implementation

{$R *.DFM}

procedure TFrameEditForm.BitBtnColorClick(Sender: TObject);
begin
  ColorDialog.Execute;
end;

procedure TFrameEditForm.FormShow(Sender: TObject);
begin
  ColorDialog.Color:=ThFrame.Color;
  EditTop.Checked:=ThFrame.DrawTop;
  EditBottom.Checked:=ThFrame.DrawBottom;
  EditLeft.Checked:=ThFrame.Drawleft;
  EditRight.Checked:=ThFrame.DrawRight;
  EditWidth.Value:=ThFrame.Width;
  EditStyle.ItemIndex:=ord(ThFrame.Style);
end;

procedure TFrameEditForm.BitBtnOkClick(Sender: TObject);
begin
  ThFrame.Color:=ColorDialog.Color;
  ThFrame.DrawTop:=EditTop.Checked;
  ThFrame.DrawBottom:=EditBottom.Checked;
  ThFrame.Drawleft:=EditLeft.Checked;
  ThFrame.DrawRight:=EditRight.Checked;
  ThFrame.Width:=EditWidth.Value;
  ThFrame.Style:=TPenStyle(EditStyle.ItemIndex);
end;

end.
