unit GetNewTypeUnit;

{*********************************************}
{*   RepoEdit -  QuickReport Editor          *}
{*   for Delphi 4                            *}
{*   (R) Copyright                           *}
{*   Borzov Vladimir borzov@rsm.ru           *}
{*********************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Buttons, ExtCtrls;

type
  TGetNewTypeForm = class(TForm)
    N1: tspeedbutton;
    N5: tspeedbutton;
    N3: tspeedbutton;
    C1: tspeedbutton;
    N4: tspeedbutton;
    N2: tspeedbutton;
    N6: tspeedbutton;
    N7: tspeedbutton;
    RichText1: tspeedbutton;
    N9: tspeedbutton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    procedure N1Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure C1Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure RichText1Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GetNewTypeForm: TGetNewTypeForm;

implementation

{$R *.DFM}

uses RepoEdit,QuickRPT,QRCTRLS,QRPRNTR,EditFileUnit,
  MessUnit;

procedure TGetNewTypeForm.N1Click(Sender: TObject);
var ThName:string;
    i:integer;
begin
 (Owner as TRepoEdit).AppendObj:=TQrLabel.Create((Owner as TRepoEdit).MainWin);
 i:=1;
 repeat
   ThName:='New_Label'+inttostr(i);
   if ((Owner as TRepoEdit).MainWin.FindComponent(ThName)<>nil)
     then ThName:='';
   if ThName<>'' then   (Owner as TRepoEdit).AppendObj.Name:=ThName;
   inc(i);
 until ThName<>'';
 Close;
end;

procedure TGetNewTypeForm.N5Click(Sender: TObject);
var  ThName:string;
    i:integer;
begin
 (Owner as TRepoEdit).AppendObj:=TQrdbtext.Create((Owner as TRepoEdit).MainWin);
 i:=1;
 repeat
   ThName:='New_DBText'+inttostr(i);
   if ((Owner as TRepoEdit).MainWin.FindComponent(ThName)<>nil)
      then ThName:='';
   if ThName<>'' then   (Owner as TRepoEdit).AppendObj.Name:=ThName;
   inc(i);
 until ThName<>'';
 Close;
end;

procedure TGetNewTypeForm.N3Click(Sender: TObject);
var ThName:string;
    i:integer;
begin
 (Owner as TRepoEdit).AppendObj:=TQRExpr.Create((Owner as TRepoEdit).MainWin);
 i:=1;
 repeat
   ThName:='New_Expr'+inttostr(i);
   if ((Owner as TRepoEdit).MainWin.FindComponent(ThName)<>nil)
      then ThName:='';
   if ThName<>'' then   (Owner as TRepoEdit).AppendObj.Name:=ThName;
   inc(i);
 until ThName<>'';
 Close;
end;

procedure TGetNewTypeForm.C1Click(Sender: TObject);
var ThName:string;
    i:integer;
begin
 (Owner as TRepoEdit).AppendObj:=TQRSysData.Create((Owner as TRepoEdit).MainWin);
 i:=1;
 repeat
   ThName:='New_SysData'+inttostr(i);
   if ((Owner as TRepoEdit).MainWin.FindComponent(ThName)<>nil)
       then ThName:='';
   if ThName<>'' then   (Owner as TRepoEdit).AppendObj.Name:=ThName;
   inc(i);
 until ThName<>'';
 Close;
end;

procedure TGetNewTypeForm.N4Click(Sender: TObject);
var ThName:string;
    i:integer;
begin
 (Owner as TRepoEdit).AppendObj:=TQRMemo.Create((Owner as TRepoEdit).MainWin);
 ((Owner as TRepoEdit).AppendObj as tqrMemo).AutoSize:=false;
 ((Owner as TRepoEdit).AppendObj as tqrMemo).Width:=100;
 ((Owner as TRepoEdit).AppendObj as tqrMemo).height:=100;
 i:=1;
 repeat
   ThName:='New_Memo'+inttostr(i);
   if ((Owner as TRepoEdit).MainWin.FindComponent(ThName)<>nil)
       then ThName:='';
   if ThName<>'' then   (Owner as TRepoEdit).AppendObj.Name:=ThName;
   inc(i);
 until ThName<>'';
 Close;
end;

procedure TGetNewTypeForm.N2Click(Sender: TObject);
var ThName:string;
    i:integer;
begin
 (Owner as TRepoEdit).AppendObj:=TQRImage.Create((Owner as TRepoEdit).MainWin);
 i:=1;
 repeat
   ThName:='New_Image'+inttostr(i);
   if ((Owner as TRepoEdit).MainWin.FindComponent(ThName)<>nil)
      then ThName:='';
   if ThName<>'' then   (Owner as TRepoEdit).AppendObj.Name:=ThName;
   inc(i);
 until ThName<>'';
 Close;
end;

procedure TGetNewTypeForm.N6Click(Sender: TObject);
var ThName:string;
    i:integer;
begin
 (Owner as TRepoEdit).AppendObj:=TQRDBImage.Create((Owner as TRepoEdit).MainWin);
 i:=1;
 repeat
   ThName:='New_DBImage'+inttostr(i);
   if ((Owner as TRepoEdit).MainWin.FindComponent(ThName)<>nil)
       then ThName:='';
   if ThName<>'' then   (Owner as TRepoEdit).AppendObj.Name:=ThName;
   inc(i);
 until ThName<>'';
 Close;
end;

procedure TGetNewTypeForm.RichText1Click(Sender: TObject);
var ThName:string;
    i:integer;
begin
 (Owner as TRepoEdit).AppendObj:=TQRRichText.Create((Owner as TRepoEdit).MainWin);
 i:=1;
 repeat
   ThName:='New_RichText'+inttostr(i);
   if ((Owner as TRepoEdit).MainWin.FindComponent(ThName)<>nil)
      then ThName:='';
   if ThName<>'' then   (Owner as TRepoEdit).AppendObj.Name:=ThName;
   inc(i);
 until ThName<>'';
 Close;
end;

procedure TGetNewTypeForm.N9Click(Sender: TObject);
var ThName:string;
    i:integer;
    ThBand:TQRBand;
begin
   ThBand:=TQRBand.Create((Owner as TRepoEdit).Mainwin);
   ThBand.BandType:=rbsummary;
   thBand.ParentReport:=(Owner as TRepoEdit).ThReport;
   ThBand.Parent:=(Owner as TRepoEdit).ThReport;
   (Owner as trepoEdit).SetEvents;
   i:=1;
   repeat
     ThName:='New_Band'+inttostr(i);
     if ((Owner as TRepoEdit).mainWin.FindComponent(ThName)<>nil)
        then ThName:='';
     if ThName<>'' then   ThBand.Name:=ThName;
     inc(i);
   until ThName<>'';
   Close;

end;

procedure TGetNewTypeForm.N7Click(Sender: TObject);
var ThName:string;
    i:integer;
begin
 (Owner as TRepoEdit).AppendObj:=TQRShape.Create((Owner as TRepoEdit).MainWin);
 i:=1;
 repeat
   ThName:='New_Shape'+inttostr(i);
   if ((Owner as TRepoEdit).MainWin.FindComponent(ThName)<>nil)
      then ThName:='';
   if ThName<>'' then   (Owner as TRepoEdit).AppendObj.Name:=ThName;
   inc(i);
 until ThName<>'';
 Close;
end;

end.
 