{*********************************************}
{*   RepoEdit -  QuickReport Editor          *}
{*   for Delphi 4                            *}
{*   (R) Copyright                           *}
{*   Borzov Vladimir borzov@rsm.ru           *}
{*********************************************}
unit SeeAllUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,
  QuickRPT,QRCTRLS,QRPRNTR,
  RepoEdit;

type
  TSeeAllForm = class(TForm)
    Spis: TListBox;
    BitBtnOk: TBitBtn;
    BitBtn2: TBitBtn;
    procedure SpisDblClick(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    UserVibor:TComponent;
    ThEditor:TRepoEdit;
  end;

var
  SeeAllForm: TSeeAllForm;

implementation

{$R *.DFM}

procedure TSeeAllForm.SpisDblClick(Sender: TObject);
begin
  BitBtnOk.Click;
end;

procedure TSeeAllForm.BitBtnOkClick(Sender: TObject);
var Str:string;
begin
  if (Spis.ItemIndex<Spis.Items.Count) and (Spis.ItemIndex>0) then begin
    Str:=Spis.Items[Spis.ItemIndex];
    Str:=Copy(str,1,Pos(' : ',str)-1);
    if assigned(thEditor) then UserVibor:=ThEditor.mainwin.FindComponent(Str);
    close;
  end;
end;

procedure TSeeAllForm.FormShow(Sender: TObject);
var i:integer;
    Str:string;
begin
  Spis.Items.Clear;
  if Assigned(ThEditor) then
      for i:=0 to thEditor.mainwin.ComponentCount-1 do
        if (ThEditor.mainwin.Components[i] is TQrBasePanel)
           or (ThEditor.mainwin.Components[i] is TQrPrintable)
        then  begin
          Str:=thEditor.mainwin.Components[i].Name+' : ';
          if thEditor.mainwin.Components[i] is TQRLabel then
            Str:=Str+'Label'+' - '+
              (thEditor.mainwin.Components[i] as TQRLabel).Caption
          else   if thEditor.mainwin.Components[i] is TQRDBText then
            Str:=Str+'Field'+' - '+
              (thEditor.mainwin.Components[i] as TQRDBText).Caption
          else if thEditor.mainwin.Components[i] is TQRMemo then
            Str:=Str+'Text downloaded from file'+' - '+
              (thEditor.mainwin.Components[i] as TQRMemo).Caption
          else if thEditor.mainwin.Components[i] is TQRImage then
            Str:=Str+'Picture downloaded from file'
          else if thEditor.mainwin.Components[i] is TQRDBImage then
            Str:=Str+'Picture - field'
          else if thEditor.mainwin.Components[i] is TQRShape then
            Str:=Str+'Shape'
          else if thEditor.mainwin.Components[i] is TQRExpr then
            Str:=Str+'Summary data'+' - '+
              (thEditor.mainwin.Components[i] as TQRexpr).Caption
          else if thEditor.mainwin.Components[i] is TQRSysData then
            Str:=Str+'System data'+' - '+
              (thEditor.mainwin.Components[i] as TQRSysData).Caption
          else if thEditor.mainwin.Components[i] is TQRBand then
            Str:=Str+'Panel'
          else if thEditor.mainwin.Components[i] is TQRSubDetail then
            Str:=Str+'Subdetail panel'
          else if thEditor.mainwin.Components[i] is TQRRichText then
            Str:=Str+'Rich-text'
          else if thEditor.mainwin.Components[i] is TQRDBRichText then
            Str:=Str+'Field in RTF';

          Spis.Items.Add(Str);
        end
end;

procedure TSeeAllForm.FormCreate(Sender: TObject);
begin
  ThEditor:=nil;
  userVibor:=nil;
end;

end.
