{*********************************************}
{*********************************************}
{*   RepoEdit -  QuickReport Editor          *}
{*   for Delphi 4                            *}
{*   (R) Copyright                           *}
{*   Borzov Vladimir borzov@rsm.ru           *}
{*********************************************}
unit VarConfirmUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Spin, ExtCtrls, {Animate,} QuickRpt,qrprntr,PreviewUnit,math;


type
  TVarConfirmForm = class(TForm)
    BitBtnPrint: TBitBtn;
    BitBtnPreview: TBitBtn;
    BitBtnNo: TBitBtn;
    SpinEditCount: TSpinEdit;
    LabCopyes: TLabel;
    BitBtnEdit: TBitBtn;
    LabCurrentVariant: TLabel;
    EditCurrentVariant: TComboBox;
    Image1: TImage;
    Bevel2: TBevel;
    CheckInOnePaper: TCheckBox;
    QRCompositeReport: TQRCompositeReport;
    CheckLoad: TCheckBox;
    BtnStyle: TBitBtn;
    function GetCount:integer;
    procedure QRCompositeReportAddReports(Sender: TObject);
    procedure BtnStyleClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtnNoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    thRep:TquickRep;
  end;


//function GetVarRepoConfirm(Text:String;var ThCount:integer;var ThCurrVar:integer):TModalResult;


var
  VarConfirmForm: TVarConfirmForm;

implementation

{$R *.DFM}

uses VarFormStyleUnit,RepoEdit;


function TVarConfirmForm.GetCount :integer;
begin
  result:=SpinEditCount.Value;
end;


procedure TVarConfirmForm.QRCompositeReportAddReports(Sender: TObject);
var i:integer;
begin
  for i:=1 to SpinEditCount.Value do begin
//    thReport.Name:=thReport.name+inttostr(i);

    (Sender as  TQRCompositeReport).Reports.Add(thRep);
  end;

end;

procedure TVarConfirmForm.BtnStyleClick(Sender: TObject);
var thFormStyle:TFormStyle;
begin
  with TVarFormStyleForm.create(Self) do
  try
      if previewUnit.previewFormStyle=fsNormal
      then EditStyle.ItemIndex:=0
      else
      if previewUnit.previewFormStyle=fsStayOnTop
      then EditStyle.ItemIndex:=1
      else EditStyle.ItemIndex:=2;

      if (ShowModal=mrOk)
      then begin
        if EditStyle.ItemIndex=0 then PreviewUnit.PreviewFormStyle:=fsNormal
        else if EditStyle.ItemIndex=1 then PreviewUnit.PreviewFormStyle:=fsStayOnTop
        else PreviewUnit.PreviewFormStyle:=fsMDIChild;

//        if Assigned(RepoEdit.Inifile) then begin
//          RepoEdit.IniFile.writeInteger(PreviewUnit.RegSectionName,PreviewUnit.RegParamName,EditStyle.itemindex);
//        end;
      end;
  finally
      free
  end;
end;

procedure TVarConfirmForm.FormCreate(Sender: TObject);
var i,thTop:integer; //thLeft:integer;
begin
    thTop:=Top;
//    thLeft:=Left;

    for i:=0 to Screen.FormCount-1 do
       if not (Screen.Forms[i]=self) and ((Screen.Forms[i] is TVarConfirmForm))
       then begin
         thTop:=thTop+getsystemmetrics(SM_CYSMCAPTION);
       end;

    if (thTop<>Top) then begin
      position:=poDesigned;
      Top:=thTop;
//      Left:=thLeft;
    end;

    Update;
end;

procedure TVarConfirmForm.BitBtnNoClick(Sender: TObject);
begin
  Close;
end;

end.
