{*********************************************}
{*   RepoEdit -   QuickReport *}
{*    Delphi 4                          *}
{*   (C) Copyright                           *}
{*                             *}
{*********************************************}
unit PanelUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls, Menus, Db, DBTables,ConfirmUnit1, ToolWin,
  ComCtrls, Spin;
type
  TPanelForm = class(TForm)
    PanelTop: TControlBar;
    ToolBar1: TToolBar;
    BtnParam: TSpeedButton;
    BtnChangeName: TSpeedButton;
    BtnDelete: TSpeedButton;
    SpeedButtonClear: TSpeedButton;
    BtnSeeAll: TSpeedButton;
    SpeedButton1: TSpeedButton;
    ToolBar2: TToolBar;
    BtnSave: TSpeedButton;
    SpButtonPlus: TSpeedButton;
    ToolBar3: TToolBar;
    BtnCancel: TSpeedButton;
    EditHideDisabled: TSpeedButton;
    ToolBar4: TToolBar;
    EditFont: TComboBox;
    EditFontSize: TComboBox;
    ToolButton3: TToolButton;
    BtnFontBold: TSpeedButton;
    BtnFontItalic: TSpeedButton;
    BtnFontUnderline: TSpeedButton;
    BtnAlignLeft: TSpeedButton;
    BtnAlignCenter: TSpeedButton;
    BtnAlignRight: TSpeedButton;
    ToolButton2: TToolButton;
    ToolButton4: TToolButton;
    BtnFont: TSpeedButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    FontDialog: TFontDialog;
    ToolButton8: TToolButton;
    BtnMinus: TSpeedButton;
    ToolBar5: TToolBar;
    LabLeft: TLabel;
    EditLeft: TSpinEdit;
    LabTop: TLabel;
    EditTop: TSpinEdit;
    LabWidth: TLabel;
    EditWidth: TSpinEdit;
    LabHeight: TLabel;
    EditHeight: TSpinEdit;
    ToolButton9: TToolButton;
    EditEnabled: TCheckBox;
    ToolBar6: TToolBar;
    EditCaption: TComboBox;
    EditLines: TBitBtn;
    OpenDialog: TOpenDialog;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditHideDisabledClick(Sender: TObject);
    procedure SpButtonPlusClick(Sender: TObject);
    procedure RichText1Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BtnDeleteClick(Sender: TObject);
    procedure SpeedButtonClearClick(Sender: TObject);
    procedure BtnFontClick(Sender: TObject);
    procedure EditFontChange(Sender: TObject);
    procedure BtnFontBoldClick(Sender: TObject);
    procedure BtnMinusClick(Sender: TObject);
    procedure EditLeftChange(Sender: TObject);
    procedure EditWidthChange(Sender: TObject);
    procedure EditEnabledClick(Sender: TObject);
    procedure EditLinesClick(Sender: TObject);
    procedure EditCaptionChange(Sender: TObject);
  private
    { Private declarations }
    FOldOnClose:TCloseEvent;
    CannotSave:boolean;
  public
    { Public declarations }
    property OldOnClose:TCloseEvent read FOldOnClose write FOldOnClose;
    procedure SetEnabledBV(Value:boolean);
    procedure ThOnClose(Sender: TObject; var Action: TCloseAction);
    procedure SetFontButtons;
    procedure SetFontValues;
  end;

var
  PanelForm: TPanelForm;

implementation

{$R *.DFM}

uses RepoEdit,QuickRPT,QRCTRLS,QRPRNTR,EditFileUnit,
  MessUnit,GetNewTypeUnit,qrextra,GetMemoTextUnit,qrExpBld;


procedure TPanelForm.SetFontValues;
var Selected:TWinControl;
    i:integer;
begin

  FontDialog.Font.Name:=EditFont.Text;
  try
    FontDialog.font.Size:=strtoint(EditFontSize.text);
  except
  end;

  if BtnFontBold.Down
  then fontdialog.Font.Style:=fontdialog.Font.Style+[fsBold]  // system.Include(FontDialog.Font.style,fsBold)
  else fontdialog.Font.Style:=fontdialog.Font.Style-[fsBold];
  if BtnFontItalic.Down
  then fontdialog.Font.Style:=fontdialog.Font.Style+[fsItalic]
  else fontdialog.Font.Style:=fontdialog.Font.Style-[fsItalic];
  if BtnFontUnderline.Down
  then fontdialog.Font.Style:=fontdialog.Font.Style+[fsUnderline]
  else fontdialog.Font.Style:=fontdialog.Font.Style-[fsUnderline];

  if owner is TRepoEdit then Selected:=(Owner as TRepoEdit).Selected
  else Selected:=nil;


  if Assigned(selected)
     and ((Selected is TQRCustomLabel)
          or (Selected is TQRCustomRichText)
          or (Selected is TQRCustomBand)
          or (Selected is TQuickRep)
         )
  then begin
    if Selected is TQuickRep then (Selected as TQuickRep).Font:=FontDialog.Font
    else if Selected is TqrCustomLabel then (Selected as TqrCustomLabel).Font:=FontDialog.Font
    else if Selected is TqrCustomRichText then (Selected as TqrCustomRichText).Font:=FontDialog.Font
    else (Selected as TqrCustomBand).Font:=FontDialog.Font;
  end;

  if Assigned(selected) and
     ((Selected is TQRCustomLabel)
      or (Selected is TQRCustomRichText)
     )
  then begin
    BtnAlignLeft.Enabled:=true;
    BtnAlignCenter.Enabled:=true;
    BtnAlignRight.Enabled:=true;
    if Selected is TqrCustomLabel then begin
      if BtnAlignLeft.down then (Selected as tqrCustomLabel).Alignment:=taleftjustify
      else if BtnAlignRight.down then (Selected as tqrCustomLabel).Alignment:=taRightjustify
      else if BtnAlignCenter.down then (Selected as tqrCustomLabel).Alignment:=taCenter;
    end
    else begin
      if BtnAlignLeft.down then (Selected as TQRCustomRichText).Alignment:=taleftjustify
      else if BtnAlignRight.down then (Selected as TQRCustomRichText).Alignment:=taRightjustify
      else if BtnAlignCenter.down then (Selected as TQRCustomRichText).Alignment:=taCenter;
    end
  end;

  if assigned(Selected)
  then begin

    if Selected is TQRDBText then (Selected as TQRDBText).DataField:=EditCaption.Text
    else if Selected is TQREXPr then begin
      (Selected as TQREXPR).Expression:=EditCaption.Text;
    end
    else
     if Selected is TQRDBImage then (Selected as TQRDBImage).DataField:=EditCaption.Text
    else if selected is TQRSysData then (selected as TQRsysdata).Text:=EditCaption.Text
    else if selected is TQRCustomLabel then (selected as TQRCustomlabel).Caption:=EditCaption.Text;

    selected.SetBounds(editLeft.Value,EditTop.Value,Editwidth.Value,EditHeight.Value);
    application.ProcessMessages;
    (Owner as TRepoEdit).SetRectCoord;

    Selected.enabled:=EditEnabled.Checked;
    for i:=0 to selected.ControlCount-1 do
      if selected.Controls[i] is tEnabledLab then begin
         selected.Controls[i].Visible:=not selected.Enabled;
         break
      end;

    (Owner as TRepoEdit).thReport.Repaint;
  end
  else begin
  end;
end;

procedure TPanelForm.SetFontButtons;
var Selected:TWinControl;
    i,k:integer;
    thDataSet:TDataset;
begin
  if owner is TRepoEdit then Selected:=(Owner as TRepoEdit).Selected
  else Selected:=nil;

  if Assigned(selected)
     and ((Selected is TQRCustomLabel)
          or (Selected is TQRCustomRichText)
          or (Selected is TQRCustomBand)
          or (Selected is TQuickRep)
         )
  then begin
    if Selected is TQuickRep then FontDialog.Font:=(Selected as TQuickRep).Font
    else if Selected is TqrCustomLabel then FontDialog.Font:=(Selected as TqrCustomLabel).Font
    else if Selected is TqrCustomRichText then FontDialog.Font:=(Selected as TqrCustomRichText).Font
    else FontDialog.Font:=(Selected as TqrCustomBand).Font;

    Btnfont.Enabled:=true;
    EditFont.Enabled:=true;
    EditFontSize.Enabled:=true;
    BtnFontBold.Enabled:=true;
    BtnFontItalic.Enabled:=true;
    BtnFontUnderline.enabled:=true;
    BtnAlignLeft.Enabled:=true;
    BtnAlignCenter.Enabled:=true;
    BtnAlignRight.Enabled:=true;

    EditFont.Text:=FontDialog.font.Name;
    EditFontSize.Text:=inttostr(FontDialog.Font.size);
    BtnFontBold.Down:=fsBold in FontDialog.Font.Style;
    BtnFontItalic.Down:=fsItalic in FontDialog.Font.Style;
    BtnFontUnderline.Down:=fsUnderline in FontDialog.Font.Style;

  end
  else begin
    Btnfont.Enabled:=false;
    EditFont.Text:='';
    EditFont.Enabled:=false;
    EditFontSize.Text:='';
    EditFontSize.Enabled:=false;
    BtnFontBold.Enabled:=false;
    BtnFontItalic.Enabled:=false;
    BtnFontUnderline.enabled:=false;
    BtnAlignLeft.Enabled:=false;
    BtnAlignCenter.Enabled:=false;
    BtnAlignRight.Enabled:=false;
  end;

  if Assigned(selected) and
     ((Selected is TQRCustomLabel)
      or (Selected is TQRCustomRichText)
     )
  then begin
    BtnAlignLeft.Enabled:=true;
    BtnAlignCenter.Enabled:=true;
    BtnAlignRight.Enabled:=true;
    if Selected is TqrCustomLabel then begin
      BtnAlignLeft.down:=(Selected as tqrCustomLabel).Alignment=taleftjustify;
      BtnAlignRight.down:=(Selected as tqrCustomLabel).Alignment=taRightjustify;
      BtnAlignCenter.down:=(Selected as tqrCustomLabel).Alignment=taCenter;
    end
    else begin
      BtnAlignLeft.down:=(Selected as TQRCustomRichText).Alignment=taleftjustify;
      BtnAlignRight.down:=(Selected as TQRCustomRichText).Alignment=taRightjustify;
      BtnAlignCenter.down:=(Selected as TQRCustomRichText).Alignment=taCenter;
    end
  end
  else begin
    BtnAlignLeft.Enabled:=false;
    BtnAlignCenter.Enabled:=false;
    BtnAlignRight.Enabled:=false;
  end;

  if assigned(Selected)
  then begin
    EditTop.enabled:=true;
    EditWidth.enabled:=true;
    EditLeft.enabled:=true;
    EditHeight.enabled:=true;
    LabTop.enabled:=true;
    LabWidth.enabled:=true;
    LabLeft.enabled:=true;
    LabHeight.enabled:=true;

    EditTop.OnChange:=nil;
    EditWidth.Onchange:=nil;
    EditLeft.OnChange:=nil;
    EditHeight.OnChange:=nil;
    EditTop.Value:=selected.Top;
    EditWidth.Value:=selected.Width;
    EditLeft.Value:=selected.Left;
    EditHeight.Value:=selected.Height;
    EditTop.OnChange:=EditLeftChange;
    EditWidth.Onchange:=EditwidthChange;
    EditLeft.OnChange:=EditLeftChange;
    EditHeight.OnChange:=EditLeftChange;
    EditEnabled.Enabled:=true;

    EditEnabled.OnClick:=nil;
    EditEnabled.Checked:=Selected.Enabled;
    EditEnabled.OnClick:=EditEnabledClick;

    EditCaption.Enabled:=true;

    EditCaption.OnChange:=nil;

    EditCaption.Style:=csSimple;
    EditCaption.Update;
    EditCaption.Items.Clear;

    if selected is TQRDBText then begin
      EditCaption.Style:=csDropDown;
      for i:=0 to selected.Owner.ComponentCount-1 do
        if (selected.Owner.components[i] is TDataSet) then begin
           ThDataSet:=TDataSet(selected.Owner.components[i]);
           for k:=0 to ThDataSet.FieldCount-1 do begin
             EditCaption.Items.Add(ThDataSet.Fields[k].FieldName);
           end;
        end;
      EditCaption.Text:=(Selected as TQRDBText).DataField;
    end
    else
    if selected is TQRDBImage then begin
      EditCaption.Style:=csDropDown;
      for i:=0 to selected.Owner.ComponentCount-1 do
        if (selected.Owner.components[i] is TDataSet) then begin
           ThDataSet:=TDataSet(selected.Owner.components[i]);
           for k:=0 to ThDataSet.FieldCount-1 do begin
             EditCaption.Items.Add(ThDataSet.Fields[k].FieldName);
           end;
        end;
      EditCaption.Text:=(selected as TQRDBImage).DataField;
    end
    else
    if selected is TQREXPR then EditCaption.Text:=(selected as TQREXPR).Expression
    else
    if selected is TQRSysData then EditCaption.Text:=(selected as TQRsysdata).Text
    else
    if selected is TQRCustomLabel then EditCaption.Text:=(selected as TQRCustomlabel).Caption
    else begin
       EditCaption.Enabled:=false;
       EditCaption.text:='';
    end;
    EditCaption.OnChange:=EditCaptionChange;

    editLines.Enabled:=true;
  end
  else begin
    EditTop.enabled:=false;
    EditWidth.enabled:=false;
    EditLeft.enabled:=false;
    EditHeight.enabled:=false;
    LabTop.enabled:=false;
    LabWidth.enabled:=false;
    LabLeft.enabled:=false;
    LabHeight.enabled:=false;

    EditTop.OnChange:=nil;
    EditWidth.Onchange:=nil;
    EditLeft.OnChange:=nil;
    EditHeight.OnChange:=nil;
    EditTop.Value:=0;
    EditWidth.Value:=0;
    EditLeft.Value:=0;
    EditHeight.Value:=0;
    EditTop.OnChange:=EditLeftChange;
    EditWidth.Onchange:=EditwidthChange;
    EditLeft.OnChange:=EditLeftChange;
    EditHeight.OnChange:=EditLeftChange;
    EditEnabled.Enabled:=false;
    EditEnabled.Checked:=false;
    editCaption.Enabled:=false;
    EditCaption.OnChange:=nil;
    EditCaption.Text:='';
    EditCaption.OnChange:=EditCaptionChange;
    EditLines.Enabled:=false;
  end;

end;

procedure TPanelForm.SetEnabledBV(Value:boolean);
begin
{  BtnParam.Enabled:=Value;
  BtnSave.enabled:=Value;
//  BtnCancel.Enabled:=Value;
  BtnSeeAll.Enabled:=Value;
  if Value then  BtnEnabled.Caption:=''
  else BtnEnabled.Caption:='';
  repaint;}
end;

procedure TPanelForm.FormDestroy(Sender: TObject);
var i:integer;
begin
  if owner is TRepoEdit then (Owner as TRepoEdit).thPanel:=nil;
  for i:=0 to Self.ComponentCount-1 do begin
     if (Self.Components[i] is TToolBar)
     then
     with Self.Components[i] as tToolbar do begin
            RepoEdit.IniFile.WriteInteger(SElf.ClassName,Name+'_Left',Left);
            RepoEdit.IniFile.WriteInteger(SElf.ClassName,Name+'_Top',Top);
     end
  end;
end;

procedure TPanelForm.FormCreate(Sender: TObject);
var i:integer;
    thComp:TComponent;
begin
  FOldOnClose:=nil;
  CannotSave:=false;
  EditFont.items.Clear;
  EditFont.Items:=qrPrntr.GetFonts;
  EditFont.Sorted := True;
  EditFontSize.Items.clear;
  PopulateFontSizeCombo(EditFontSize);
  SetFontButtons;

  IniCheck;
  try
  for i:=0 to Self.ComponentCount-1 do begin
     THComp:=Self.Components[i];
     if (ThComp is TToolBar)
     then begin
//        if (ThComp as TToolBar).Wrapable then  (ThComp as TToolBar).Wrapable:=false;
//        if not (ThComp as TToolBar).AutoSize then  (ThComp as TToolBar).AutoSize:=true;

//        (ThComp as TToolBar).Visible:=MyIniFile.ReadBool(Self.ClassName,(ThComp as TToolBar).Name+'_Visible',(ThComp as TToolBar).Visible);
        (ThComp as TToolBar).Left:=REpoEdit.IniFile.ReadInteger(Self.ClassName,(ThComp as TToolBar).Name+'_Left',(ThComp as TToolBar).Left);
        (ThComp as TToolBar).Top:=REpoEdit.IniFile.readInteger(Self.ClassName,(ThComp as TToolBar).Name+'_Top',(ThComp as TToolBar).Top);
     end;
  end;
  except
  end;

end;

procedure TPanelForm.ThOnClose(Sender: TObject; var Action: TCloseAction);
var //i:integer;
//    ThComp:TComponent;
    Res:TModalResult;
begin
  if not CannotSave then Res:=GetConfirm('  ?')
  else begin
    Res:=mrCancel;
    CannotSave:=false;
  end;
  if Res=mrOk then  BtnSave.Click
  else if Res=mrIgnore then begin
    Action:=caNone;
    exit;
  end;

  (Sender as TForm).OnClose:=OldOnClose;
//  Self.Free;
end;


procedure TPanelForm.EditHideDisabledClick(Sender: TObject);
var i:integer;
begin
 with (Owner as TrepoEdit).mainwin do
 for i:=0 to ComponentCount-1 do
 if not (Components[i] is Tquickrep)
    and
    (Components[i] is TControl)
    and
    not (Components[i] as TControl).enabled
 then begin
   (Components[i] as TControl).Visible:=EditHideDisabled.Down
 end;
 (Owner as TRepoEdit).thForm.Repaint;
end;

procedure TPanelForm.SpButtonPlusClick(Sender: TObject);
begin
  with TGetNewTypeForm.create(Owner) do
  try
    Parent:=Self.Parent;
    ShowModal;
  finally
    free;
  end
end;


procedure TPanelForm.RichText1Click(Sender: TObject);
var ThName:string;
    i:integer;
begin
 (Owner as TRepoEdit).AppendObj:=TQRRichText.Create((Owner as TRepoEdit).MainWin);
 i:=1;
 repeat
   ThName:='New_RichText'+inttostr(i);
   if ((Owner as TRepoEdit).MainWin.FindComponent(ThName)<>nil)
      then ThName:='';
   if ThName<>'' then   (Owner as TRepoEdit).AppendObj.Name:=ThName;
   inc(i);
 until ThName<>'';
end;

procedure TPanelForm.N9Click(Sender: TObject);
var ThName:string;
    i:integer;
    ThBand:TQRBand;
begin
   ThBand:=TQRBand.Create((Owner as TRepoEdit).Mainwin);
   ThBand.BandType:=rbsummary;
   thBand.ParentReport:=(Owner as TRepoEdit).ThReport;
   ThBand.Parent:=(Owner as TRepoEdit).ThReport;
   (Owner as trepoEdit).SetEvents;
   i:=1;
   repeat
     ThName:='New_Band'+inttostr(i);
     if ((Owner as TRepoEdit).mainWin.FindComponent(ThName)<>nil)
        then ThName:='';
     if ThName<>'' then   ThBand.Name:=ThName;
     inc(i);
   until ThName<>'';

end;

procedure TPanelForm.SpeedButton1Click(Sender: TObject);
begin
  with TEditFileForm.Create(Application) do
  try
    if RepoEdit.TaReport.databaseName<>'' then Table.TableName:=RepoEdit.taReport.databaseName;
    Table.Tablename:=RepoEdit.taReport.tableName;
    Table.Open;
    Showmodal;
    if table.State in [dsEdit,dsInsert] then Table.Post;
    Table.FlushBuffers;
  finally
    Free;
  end;
end;

procedure TPanelForm.BtnDeleteClick(Sender: TObject);
begin
  if (GetConfirmSmall('    ?')=mrOk)
  then begin
    (Owner as TRepoEdit).DeleteSavedReport(True);
    bvMess('   !'+#13+'     !');
    Cannotsave:=true;
    self.Close;
    exit;
  end;

end;


procedure TPanelForm.SpeedButtonClearClick(Sender: TObject);
begin
  if (GetConfirmSmall('    ,   ?')=mrOk)
  then begin
    (Owner as TRepoEdit).DeleteSavedReport(false);
    bvMess('     !');
    CAnnotSave:=true;
    self.Close;
    exit;
  end;

end;

procedure TPanelForm.BtnFontClick(Sender: TObject);
var Selected:TWinControl;
begin
  if owner is TRepoEdit then Selected:=(Owner as TRepoEdit).Selected
  else Selected:=nil;

  if FontDialog.Execute
     and Assigned(selected)
     and ((Selected is TQRCustomLabel)
          or (Selected is TQRCustomRichText)
          or (Selected is TQRCustomBand)
          or (Selected is TQuickRep)
         )
  then begin
    if Selected is TQuickRep then (Selected as TQuickRep).Font:=FontDialog.Font
    else if Selected is TqrCustomLabel then (Selected as TqrCustomLabel).Font:=FontDialog.Font
    else if Selected is TqrCustomRichText then (Selected as TqrCustomRichText).Font:=FontDialog.Font
    else (Selected as TqrCustomBand).Font:=FontDialog.Font;
  end;

 SEtFontButtons;
 SetFontValues;
end;

procedure TPanelForm.EditFontChange(Sender: TObject);
begin
  SetFontValues;
end;

procedure TPanelForm.BtnFontBoldClick(Sender: TObject);
begin
  SetFontValues;
end;

procedure TPanelForm.BtnMinusClick(Sender: TObject);
var Selected:TWinControl;
begin
   if owner is TRepoEdit then Selected:=(Owner as TRepoEdit).Selected
   else Selected:=nil;

   if assigned(Selected) and (pos('New_',SElected.Name)=1)
   then
   try
     selected.free;
     Selected:=nil;
     (Owner as TRepoEdit).ThForm.Repaint;
   except
     on e:exception do bvMessError('   !'+#13+#13+
         ': '+e.Message)
     else raise
   end
end;

procedure TPanelForm.EditLeftChange(Sender: TObject);
begin
  SetFontValues;
end;

procedure TPanelForm.EditWidthChange(Sender: TObject);
begin
  SetFontValues;
  Application.ProcessMessages;
  if Assigned((Owner as TrEpoEdit).Selected) and ((Owner as TrEpoEdit).selected.Width<>EditWidth.Value)
  then editwidth.value:=(Owner as TrEpoEdit).selected.width  //autoselect
end;

procedure TPanelForm.EditEnabledClick(Sender: TObject);
begin
  SetFontValues
end;

procedure TPanelForm.EditLinesClick(Sender: TObject);
var str:string;
    Selected:TWinControl;
begin
  if owner is TRepoEdit then Selected:=(Owner as TRepoEdit).Selected
  else Selected:=nil;

  if (Selected is TQRRichText) or (Selected is TQRMemo) then begin

    OpenDialog.FileName:=(Owner as TRepoEdit).GetDopParam(Selected,'LINES');

    if (OpenDialog.Execute) then begin
     (Owner as TRepoEdit).SetDopParam(Selected,'LINES',OpenDialog.FileName);
     try
      if (Selected is TQRRichText)
         then (Selected as TQRRichText).Lines.LoadFromFile(OpenDialog.FileName)
      else (Selected as TQRMemo).Lines.LoadFromFile(OpenDialog.FileName);
     except
       on e:exception do bvMessError('   '+#13+
                  ':'+E.Message);
     end;
    end;
  end
  else if Selected is TQRExpr then begin
    str:=editcaption.text;
    GetExpression( ' ',str,nil,nil,nil);
    editcaption.text:=str;
  end
  else if Selected is tqrCustomLabel then
  with tGetmemoTextForm.Create(application) do
  try
    Memo.Text:=Self.EditCaption.Text;
    if ShowModal=mrOk then Self.EditCaption.Text:=Memo.Text;
  finally
     free;
  end;
  EditCaptionChange(EditCaption);
end;

procedure TPanelForm.EditCaptionChange(Sender: TObject);
begin
  SetFontValues;
end;

end.
