{*********************************************}
{*   RepoEdit -   QuickReport *}
{*    Delphi 4                            *}
{*   (C) Copyright                           *}
{*      borzov@rsm.ru          *}
{*   v4.7                                    *}
{*********************************************}

unit RepoEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  db, DBTables,
  QuickRPT,QRCTRLS,QRPRNTR,
  extctrls,Buttons,StdCtrls,printers,comctrls,
  VarConfirmUnit,
  PanelUnit,{bvUtils,}menus{,qrExcelF1},PreviewUnit,waitun,REgistry;

const DefaultFileName:string='bvReport.db'; // can redefine in program source
const RepoEditPath:string=''; //    taReport

var TaReport:TTable;
    function TaRepNameForm:TField;
    function TaRepNamecomp:tField;
    Function TaRepValue:TMemoField;
//    taRepNameComp:TStringField;
//    TaRepValue:TmemoField;

procedure ExecuteReport(pMain:TWinControl;pOnNeedData:tnotifyevent=nil{;pPreviewStyle:TFormStyle=fsMDIForm}); // MDIForm -   ,     INIFile


const DefaultVariantName='( )';
const REPORTPOPUPNAME='POPUPREPORT_BV';

type bvVarExistsException=Exception;

//type RepoEditPreviewType=(ptStandard,ptRepoEdit4);

//var CurrentRepoEditPreview:RepoEditPreviewType;

var
    IniFile:TReginiFile;

type
  TDopParam = class(TComponent)
  public
     ParamName:string;
     Value:string;
     constructor Create(AOwner:TComponent); override;
  end;

type TRectLab=(rlTopLeft,rlTop,rlTopRight,
               rlRight,
               rlBottomRight,rlBottom,rlBottomLeft,
               rlLeft);

type
  TRectLabel=class(TCustomControl)
  private
//    OldX,OldY:integer;
  protected
    procedure Paint; override;
  public
    ID:tRectLab;
  end;

  tEnabledLab=class(TCustomControl)
  protected
    procedure paint;override;
  public
    constructor create(AOwner:tComponent); override;
    procedure dblclickhandle(Sender:TObject);
    procedure HintHandle;
  end;

  TSelectedFrame=class(TWinControl)
  private
//    Canvas:TCanvas;
  public
//    CurrentRect : TRect;
    constructor Create(Owner:TComponent); override;
    destructor Destroy; override;
    procedure MoveFrame(ALeft, AUp : integer);
    procedure SizeFrame(ALeft, AUp, ARight, ADown : integer);
    procedure PaintFrame;
  end;

type
  TRepoEdit = class(TComponent)
  private
    { Private declarations }
    FEnabled:boolean;
    FThReport:tQuickRep;
    FThForm:TForm;
    FthPanel:TPanelForm;
    FCurrentVariant:integer;
    FOnNeedCount:TNotifyEvent;
    FOnNeedData:TNotifyEvent;

    EdF:TForm;
    CannotMouseDown:boolean;

//    ThConfirmForm:TVarConfirmForm;

    FAppendObj:TQRPrintable;

    PopupX,PopupY:integer;
    OldX,OldY:integer;

    FSelected:TWinControl;

    ThRect:array[TRectLab] of TRectlabel;

    thFrame:TSelectedFrame;

    thEnabledLab:TEnabledLab;

    thStatusBar:TStatusBar;

    IsEditing:boolean;
//    FVarC:integer;

//    function GetThForm:TForm;
//    PreviewStyle:TFormStyle; // MDIForm -   ,     INIFile

    procedure BtnParamClick(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
    procedure BtnChangeNameClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure BtnSeeAllClick(Sender: TObject);

    function GetVariantCount:integer;
//    function GetThCount:integer;

    function VariantStr:string;

    procedure OnShowPopup(Sender:TObject);
    procedure OnEnabledItemClick(Sender:TObject);
    procedure OnPropertyItemClick(Sender:TObject);
    procedure OnDeleteItemClick(Sender:TObject);
    procedure SetAppendOBJ(Value:TQRPrintable);

    function GetMainWin:TComponent;

    procedure MouseUpHandler(Sender : TObject; Button : TMouseButton; Shift : TShiftState; X, Y : integer);
    procedure MouseDownHandler(Sender : TObject; Button : TMouseButton; Shift : TShiftState; X, Y : integer);
    procedure MouseMoveHandler(Sender : TObject; Shift : TShiftState; X, Y : integer);
//    procedure PaintHANDLER(Sender: TOBJECT);
    procedure DblClickHandler(Sender:TObject);
    function FindComp(x:integer=-1000000;y:integer=-1000000):TWinControl;
    function GetContr(const Pos: TPoint;ParComp:TWinControl): TWinControl;

    procedure SetSelected(Value:TWinControl);

    procedure HideRect;
    procedure ShowRect;
    procedure thFormClose(Sender: TObject; var Action: TCloseAction);

  protected
    { Protected declarations }
    procedure Loaded; override;
  public
    { Public declarations }
    ThPopupMenu:TPopupMenu;

    procedure SetRectCoord(thleft:integer=-1000000;thright:integer=-1000000;thtop:integer=-1000000;thbottom:integer=-1000000);

    procedure SetEvents(AControl : TWinControl=nil);

    procedure SetHints(value:boolean;AControl : TWinControl=nil);

    function CorrectName:string;

    procedure RestoreReport;
    procedure SaveReport;
    function RestoreNotFrontBack(ThCompName:string):integer;
    procedure SaveNotFrontBack(ThCompName:string;Value:integer);
//    function RestoreFileName(ThComp:TComponent):String;
  //  procedure SaveFileName(ThComp:TComponent;Value:String);
    function DeleteSaved(ThComp:string):boolean;
    function DeleteSavedReport(DeleteReport:boolean):boolean;
    constructor Create(Aowner:TComponent); override;
//    constructor CreateDisable(Aowner:TComponent);
    destructor Destroy; override;
    procedure Edit;

    procedure Execute;
    function DoReport(NeedFree:boolean=false):integer;
    function DoReportBtn(Btn:integer;NeedFree:boolean=false):integer; // 0-DoReport,1- 1 ,2-...

    procedure SetDopParam(Sender:TComponent;ParamName,ParamValue:string);
    function GetDopParam(Sender:TComponent;ParamName:string):string;
    procedure SaveDopParams(Sender:TComponent;ParamList:TStringList);

    procedure CheckData;

    procedure UpdateSelected;

    property ThForm:TForm read FThForm;
    property ThReport:TQuickRep read FThReport;
    property ThPanel:TPanelForm read fThPanel write FthPanel;

    property AppendOBJ:TQRPrintable read FAppendOBJ write SetAppendOBJ;

    property MainWin:TComponent read GetMainWin;
//    property ThCount:integer read GetThCount;

    property Selected:TWinControl read fSelected write SetSelected;

  published
    { Published declarations }
    property CurrentVariant:integer read FCurrentVariant write FCurrentVariant;
    property Enabled:boolean read FEnabled write FEnabled;
    property VariantCount:integer read GetVariantCount;
    property OnNeedCount:TNotifyEvent read FOnNeedCount write FOnNeedCount;
    property OnNeedData:TNotifyEvent read FOnNeedData write FOnNeedData;
//    procedure PreviewProc(Sender:TObject);
  end;




const EnabledItemNum=0;
      DeleteItemNum=2;
      PropertyItemNum=4;



procedure Register;

function IniCheck:boolean;
//function IniCheckStructure:boolean;
function DeleteAllIndexes:boolean;
//procedure SetCurrentPreviewInterFace(Value:RepoEditPreviewType);  // 0 - Standard, 1-bvRepoEdit PreviewForm
//function GetCurrentPreviewInterFace:RepoEditPreviewType;

implementation

uses SeeAllUnit,SaveVarConfirmUnit,NewVariantUnit,
     GetNameUnit,qrExport,MessUnit,confirmunit1,actnlist,stdactns,EditFormUnit;



function TableExists(Table:TTable):boolean;
var Thext:string;
    ThPath:string;
    MyStringList:TStringList;
begin
  with Table do begin
    Result := Active;
    if Result or (TableName = '') then Exit;

    Thext:=ExtractFileExt(Table.TableName);
    ThPath:=ExtractFilePath(Table.TableName);

    if (ThPath<>'') or (databaseName='') then begin
       Result:=(ThExt<>'') and FileExists(Table.TableName)
               or (ThExt='') and (FileExists(Table.TableName+'.DB')
                                  or
                                  FileExists(Table.TableName+'.DBF')
                                  or
                                  FileExists(Table.TableName+'.TXT')
                                  )
    end
    else begin
       MyStringList := TStringList.Create;
       try
         Session.GetTableNames(databaseName,'' {*.db;*.dbf;*.txt'},
                               True, False, MyStringList);
         { Add the table names to a list box }
         if ThExt<>'' then Result:=(MyStringList.IndexOf(Tablename)>-1)
         else Result:=(MyStringList.IndexOf(Tablename+'.db')>-1)
                      or
                      (MyStringList.IndexOf(Tablename+'.dbf')>-1)
                      or
                      (MyStringList.IndexOf(Tablename+'.txt')>-1)
       finally
         MyStringList.Free;
       end;
    end;
  end;
end;

function CalcOffsetRect(AControl : TControl) : TRect;
Var thW,thH:integer;
begin
  Result:=AControl.BoundsRect;
  thW:=Result.right-Result.left;
  thH:=Result.Bottom-result.Top;
  AControl := AControl.Parent;
  while not (AControl is TQuickRep) and (AControl <> nil) do
  begin
    Result.left := Result.left + AControl.Left;
    Result.top := Result.top + AControl.Top;
    AControl := AControl.Parent;
  end;
  Result.right:=Result.Left+thW;
  Result.bottom:=Result.Top+thH;
end;

procedure SetOffsetCoord(AControl : TControl;ThRect:TRect);
Var thW,thH:integer;
    thControl:TControl;
begin
//  AControl.BoundsRect:=ThRect;
  thW:=thRect.right-thRect.left;
  thH:=thRect.Bottom-thRect.Top;
  thControl := AControl.Parent;
  while not (thControl is TQuickRep) and (thControl <> nil) do
  begin
    thRect.left := thRect.left - thControl.Left;
    thRect.top := thRect.top - thControl.Top;
    thControl := thControl.Parent;
  end;
  thRect.right:=thREct.Left+thW;
  thRect.bottom:=thRect.Top+thH;

  AControl.BoundsRect:=ThRect;
  AControl.Update;
end;


function SetBool(Value:Boolean):string;
const BoolVal: array[Boolean] of string = ('0', '1');
begin
  Result:=BoolVal[Value];
end;

function GetBool(Value:string):boolean;
begin
  Result := (Value<>'0') and (UpperCase(Value)<>'FALSE') and (UpperCase(Value)<>'F');
end;

function SetInt(Value:Integer):string;
begin
  Result:=inttostr(Value);
end;

function GetInt(Value:string):integer;
begin
  Result:=strtoint(Value);
end;


procedure Register;
begin
  RegisterComponents('QReport', [TRepoEdit]);
end;

//procedure IniCheck;

procedure TRepoEdit.thFormClose(Sender: TObject; var Action: TCloseAction);
begin
  IsEditing:=false;
end;

function TRepoEdit.GetVariantCount;
begin
  Result:=1;
end;

constructor TRepoEdit.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FEnabled:=True;
 fThReport:=nil;
 FThPanel:=nil;
 FCurrentVariant:=0;
 FOnNeedCount:=nil;
 FOnNeedData:=nil;
// ThConfirmForm:=nil;
 FAppendOBJ:=nil;
 ThPopupmenu:=nil;
 thEnabledLab:=nil;
 thFrame:=nil;
 thStatusBar:=nil;
// PreviewStyle:=fsMDIForm; // MDIForm -   ,     INIFile

 if not (csDesigning in ComponentState) then begin
    TQRCSVFilter.Create(Owner);
    TQRTextFilter.Create(Owner);
    TQRHTMLFilter.Create(Owner);
    TQREXCELFilter.Create(Owner); // if you have professional qr then uncomment this line (or qr304bv)
    TQRRTFFilter.create(Owner);  // if you have professional qr then uncomment this line (or qr304bv)
    TQRWMFFilter.create(Owner); // if you have professional qr then uncomment this line (or qr304bv)
 end;

// TQRExcelFilter.Create(AOwner);
end;


procedure TRepoEdit.SetAppendOBJ(Value:TQRPrintable);
begin
  if Assigned(FAppendOBJ) then FAppendOBJ:=nil;
  FAppendObj:=Value;
end;



destructor TRepoEdit.Destroy;
begin
  inherited Destroy;
end;


procedure TRepoEdit.Loaded;
var i:integer;
    NewForm:TForm;
    thScroll:TScrollBox;
begin
  CannotMouseDown:=false;
  if not (csDesigning in ComponentState) then begin
     if Owner is tQuickRep  then FThReport:=Owner as TQuickRep
     else if Owner is TForm then begin
       with (Owner as TForm) do
       For i:=0 to ComponentCount-1 do
          if Components[i] is TQuickRep then
            FThReport:= (Components[i] as TQuickRep);

     end
     else begin
        bvMessError('      ,   !');
        exit;
     end;

     if assigned(owner) then begin
       if (Owner is TForm) then  FThForm:=(Owner as TForm)
       else if Owner is TQuickRep then  begin
         NewForm:=TForm.Create(Self);
         NewForm.Name:='OpenWithRepoEdit_'+FThReport.Name;
         FThForm:=NewForm;
         FThReport.parent:=FThForm;
       end;

       thForm.onClose:=thFormClose;
       thScroll:=TScrollBox.Create(Self);
       thScroll.align:=alclient;
       thScroll.Parent:=fthForm;
       thReport.Parent:=thScroll;
       thScroll.Visible:=true;
     end
     else begin
        bvMessError('      ,   !');
        exit;
     end;
  end;
end;

function TRepoEdit.RestoreNotFrontBack(ThCompName:string):integer;
begin
  IniCheck;
  with TaReport do begin
    SetKey;
    TaRepNameForm.AsString:=CorrectName;
    TaRepNameComp.AsString:=ThCompName+VariantStr;
    if Gotokey then Result:=FieldByname('NotFrontback').AsInteger
    else Result:=0;
  end;
end;

procedure TRepoEdit.SaveNotFrontBack(ThCompName:string;Value:integer);
begin
  IniCheck;
  with TaReport do begin
    SetKey;
    TaRepNameForm.AsString:=CorrectName;
    TaRepNameComp.AsString:=ThCompName+VariantStr;
    if Not Gotokey then begin
      Insert;
      TaRepNameForm.AsString:=CorrectName;
      TaRepNameComp.AsString:=ThCompName+VariantStr;
    end
    else Edit;
    FieldByname('NotFrontback').AsInteger:=Value;
    Post;
  end;
end;

function TrepoEdit.DeleteSaved(ThComp:string):boolean;
begin
   IniCheck;
   try
    with TaReport do begin
        SetKey;
        taRepNameForm.AsString:=CorrectName;
        TaRepNameComp.AsString:=ThComp+VariantStr;
        if GotoKey then begin
          Delete;
          Result:=true;
        end
        else Result:=false;
    end;
   except
     Result:=false;
   end;
end;


function TrepoEdit.DeleteSavedReport(DeleteReport:boolean):boolean;
var i:integer; ThName:string;
begin
   Result:=true;
   IniCheck;
   try
    with TaReport do begin
        First;
        Locate('NameForm',CorrectName,[]);
        while not eof and (TaRepNameForm.AsString=CorrectName) do begin
          if (pos(':',TaRepNameComp.AsString)=0)
             and (CurrentVariant=0)
             or
             (pos(VariantStr,TaRepNameComp.AsString)>0)
          then begin
            if (CurrentVariant=0)
               and (TaRepNameComp.AsString=ThReport.Name)
               or
               (pos(VariantStr,TaRepNameComp.AsString)>0)
               and (TaRepNameComp.AsString=ThReport.Name+VariantStr)
          then begin
            if DeleteReport then Delete
            else with TStringList.Create do begin
               SetText(pchar(TaRepValue.asString));
               ThName:=Values['VariantName'];
               Clear;
               Values['VariantName']:=ThName;
               Edit;
               for i:=taRepNameComp.FieldNo+1 to FieldCount-1 do begin
                 fields[i].Clear;
               end;
               TaRepValue.AsString:=Text;
               Post;
               Next;
               Free;
            end
          end
          else
            Delete;
          end
          else Next;
        end;
      end;
   except
     Result:=false;
   end;
end;


procedure TRepoEdit.RestoreReport;
var
    ThComp:TComponent;
    ThFSt:TFontStyles;
    ThFileName:string;
    ThName:string;
    ThVal:integer;
    Str,Str2:string;
    ParentComp:TComponent;
    i:integer;

begin
  if csDesigning in ComponentState then exit;


  IniCheck;

  ThReport.Left:=0;
  thReport.Top:=0;

  if Enabled then  begin
    TaReport.SetKey;
    TarepNameForm.AsString:=CorrectName;
    TaRepNameComp.AsString:=ThReport.Name+VariantStr;
    if not Tareport.Gotokey then begin
      if Enabled then begin
        TaReport.insert;
        TaRepNameForm.AsString:=CorrectName;
        TaRepNamecomp.AsString:=ThReport.Name+VariantStr;
        TaReport.fieldByname('Enabled').AsBoolean:=Enabled;
        TaReport.post;
      end
    end
    else begin
      Enabled:=TaReport.FieldByname('Enabled').AsBoolean;
    end
  end;

  if Enabled then with tStringList.create do
  try

     SetText(pchar(TaRepValue.Value));


     for i:=0 to count-1 do begin

         if uppercase(Names[i])='ZOOM'
         then  ThReport.Zoom:=GetInt(Values[Names[i]])
         else If upperCase(Names[i])='PAGE.BOTTOMMARGIN'
         then  ThReport.page.BottomMargin:=strtofloat(Values[Names[i]])
         else If upperCase(Names[i])='PAGE.LEFTMARGIN'
         then  ThReport.page.LEFTMargin:=strtofloat(Values[Names[i]])
         else If upperCase(Names[i])='PAGE.RIGHTMARGIN'
         then  ThReport.page.RIGHTMargin:=strtofloat(Values[Names[i]])
         else If upperCase(Names[i])='PAGE.TOPMARGIN'
         then  ThReport.page.TOPMargin:=strtofloat(Values[Names[i]])
         else If upperCase(Names[i])='PAGE.COLUMNSPACE'
         then  ThReport.page.columnspace:=strtofloat(Values[Names[i]])
         else If upperCase(Names[i])='PAGE.LENGTH'
         then  ThReport.page.LENGTH:=strtofloat(Values[Names[i]])
         else If upperCase(Names[i])='PAGE.WIDTH'
         then  ThReport.page.WIDTH:=strtofloat(Values[Names[i]])
         else If upperCase(Names[i])='PAGE.ORIENTATION'
         then  ThReport.page.Orientation:=TPrinterOrientation(GetInt(Values[Names[i]]))
         else If upperCase(Names[i])='PAGE.PAPERSIZE'
         then  ThReport.page.PaperSize:=TQRPAPERSIZE(GetInt(Values[Names[i]]))
         else If upperCase(Names[i])='PAGE.RULER'
         then  ThReport.page.RULER:=GetBool(Values[Names[i]])
         else If upperCase(Names[i])='PAGE.COLUMNS'
         then  ThReport.page.Columns:=GetInt(Values[Names[i]])

         else If upperCase(Names[i])='PRINTERSETTINGS.COPIES'
         then  ThReport.PrinterSettings.Copies:=Getint(Values[Names[i]])
         else If upperCase(Names[i])='PRINTERSETTINGS.FIRSTPAGE'
         then  ThReport.PrinterSettings.Firstpage:=getint(Values[Names[i]])
         else If upperCase(Names[i])='PRINTERSETTINGS.LASTPAGE'
         then  ThReport.PrinterSettings.LASTPAGE:=GetInt(Values[Names[i]])
         else If upperCase(Names[i])='PRINTERSETTINGS.OUTPUTBIN'
         then  ThReport.PrinterSettings.OutputBin:=TQRBIN(GetInt(Values[Names[i]]))
         else If upperCase(Names[i])='PRINTERSETTINGS.DUPLEX'
         then  ThReport.PrinterSettings.DUPLEX:=GetBool(Values[Names[i]])
         else If upperCase(Names[i])='SNAPTOGRID'
         then  ThReport.SNAPTOGRID:=GetBool(Values[Names[i]])
         else If upperCase(Names[i])='PRINTIFEMPTY'
         then  ThReport.PRINTIFEMPTY:=getBool(Values[Names[i]])
         else If upperCase(Names[i])='UNITS'
         then  ThReport.Units :=TQRUnit(getInt(Values[Names[i]]));
     end;
///////////

     with Tareport do begin
       First;
       locate('NameForm',CorrectName,[]);

       while not EOF and (TaRepNAMEFORM.asString=CorrectName) do begin

           ThName:=FieldByname('NAMECOMPONENT').AsString;
           ThVal:=0;
           if pos(':',Thname)<>0 then begin
              ThVal:=strtoint(copy(ThName,pos(':',Thname)+1,10));
              ThName:=copy(ThName,1,pos(':',Thname)-1);
           end;

           clear;
           SetText(pchar(TaRepValue.Value));

           if ThVal=CurrentVariant then  begin
             ThComp:=MainWin.FindComponent(ThName);
             if (ThComp=nil) and (pos('New_',ThName)=1) then begin
                                         //NewComponent
                Str:=Values['TYPE'];
                if Str='' then thComp:=nil
                else begin
                  if Str='TQRBAND' then begin
                    thComp:=TQRBAND.Create(self.MainWin);
                    (thComp as TQRBand).ParentReport:=self.ThReport;
                    (thComp as TQRBand).Parent:=Self.ThReport; // TWinControl
                    ThComp.Name:=thName;
                  end
                  else begin
                    Str2:=Values['PARENT'];

                    if Str2='' then  thComp:=nil
                    else begin
                      ParentComp:=MainWin.FindComponent(Str2);
                      if ParentComp=nil then ThComp:=nil
                      else begin
                        if Str='TQRLABEL' then begin
                          thComp:=TQRLabel.Create(self.mainWin);
                          (thComp as TQRLabel).ParentReport:=self.ThReport;
                          (thComp as TQRlabel).Parent:=TWinControl(ParentComp); // TWinControl
                          ThComp.Name:=thName;
                        end
                        else  if Str='TQRDBTEXT' then begin
                          thComp:=TQRDBText.Create(self.MainWin);
                          (thComp as TQrDBText).ParentReport:=self.ThReport;
                          (ThComp as TQRDBText).DataSet:=self.ThReport.dataSet;
                          (thComp as TQRDBTEXT).Parent:=TWinControl(ParentComp); // TWinControl
                          ThComp.Name:=thName;
                        end
                        else  if Str='TQREXPR' then begin
                          thComp:=TQREXPR.Create(self.MainWin);
                          (thComp AS TQREXPR).ParentReport:=self.ThReport;
                          (thComp as TQREXPR).Parent:=TWinControl(ParentComp); // TWinControl
                          ThComp.Name:=thName;
                        end
                        else  if Str='TQRSYSDATA' then begin
                          thComp:=TQRSYSDATA.Create(self.MainWin);
                          (thComp AS TQRSYSDATA).ParentReport:=self.ThReport;
                          (thComp as TQRSYSDATA).Parent:=TWinControl(ParentComp); // TWinControl
                          ThComp.Name:=thName;
                        end
                        else  if Str='TQRMEMO' then begin
                          thComp:=TQRMEMO.Create(self.MainWin);
                          (thComp as TQRMEMO).ParentReport:=self.ThReport;
                          (thComp as TQRMEMO).Parent:=TWinControl(ParentComp); // TWinControl
                          ThComp.Name:=thName;
                        end
                        else  if Str='TQRIMAGE' then begin
                          thComp:=TQRIMAGE.Create(self.MainWin);
                          (thComp as TQRIMAGE).ParentReport:=self.ThReport;
                          (ThComp as TQRIMage).Parent:=TWinControl(ParentComp); // TWinControl
                          ThComp.Name:=thName;
                        end
                        else  if Str='TQRDBIMAGE' then begin
                          thComp:=TQRDBIMAGE.Create(self.MainWin);
                          (thComp as TQRDBimage).ParentReport:=self.ThReport;
                          (thComp as TqrDBImage).Parent:=TWinControl(ParentComp); // TWinControl
                          ThComp.Name:=thName;
                        end
                        else  if Str='TQRSHAPE' then begin
                          thComp:=TQRSHAPE.Create(self.MainWin);
                          (thComp as TQRShape).ParentReport:=self.ThReport;
                          (thComp as TQRshape).Parent:=TWinControl(ParentComp); // TWinControl
                          ThComp.Name:=thName;
                        end
                        else  if Str='TQRRICHTEXT' then begin
                          thComp:=TQRRICHTEXT.Create(self.Mainwin);
//                          (thComp as TQRRICHTEXT).CanFocus:=false;
                          (thComp as TQRRICHTEXT).ParentRichEdit:=nil;
                          (thComp as TQRRichText).ParentReport:=self.ThReport;
                          (thComp as TQRRichText).Parent:=TWinControl(ParentComp); // TWinControl
                          ThComp.Name:=thName;
                        end
                      end
                    end
                  end
                end;
             end;

             if (ThComp<>nil) and (ThComp is TCustomControl) then begin
                if Not (ThComp is TQuickRep) then begin

                   if (ThComp is TQRCustomlabel) then  (ThComp as TQRCustomLabel).AutoSize:=false
                   else if (ThComp is TQRImage) then  (ThComp as TQRImage).AutoSize:=false;

                   if not fieldByname('TOP').IsNULL then
                      (ThComp as TCustomControl).Top:=FieldByName('TOP').AsInteger;
                   if not fieldByname('LEFT').IsNULL then
                      (ThComp as TCustomControl).LEFT:=FieldByName('LEFT').AsInteger;
                   if not fieldByname('WIDTH').IsNULL then
                      (ThComp as TCustomControl).Width:=FieldByName('WIDTH').AsInteger;
                   if not fieldByname('HEIGHT').IsNULL then
                      (ThComp as TCustomControl).HEIGHT:=FieldByName('HEIGHT').AsInteger;
                   if (not (ThComp is TQRBasepanel)) and (not fieldByname('ENABLED').IsNULL) then
                      (ThComp as TCustomControl).Enabled:=FieldByName('ENABLED').AsBoolean;
                   if ((ThComp is TQRBasepanel)) and (not fieldByname('ENABLED').IsNULL) then
                      (ThComp as TqrBasePanel).Enabled:=FieldByName('ENABLED').AsBoolean;
                end;


                if Not (ThComp is TQRBasePanel) then begin
                  if not FieldbyName('NotFrontBack').IsNULL then begin
                    if FieldByname('NotFrontBack').AsInteger=1
                    then (ThComp as TCustomControl).BringToFront
                    else if FieldByname('NotFrontBack').AsInteger=2
                    then (ThComp as TCustomControl).SendToBack;
                  end;
                end;

                if ThComp is TQrPrintable then begin

                   if not fieldByname('Frame.Color').IsNULL
                   then     (ThComp as TQRPrintable).Frame.Color:=TColor(FieldByName('Frame.Color').AsInteger);

                   if not fieldByname('Frame.DrawBottom').IsNULL
                   then     (ThComp as TQRPrintable).Frame.DrawBottom:=FieldByName('Frame.DrawBottom').AsBoolean;
                   if not fieldByname('Frame.DrawLeft').IsNULL
                   then     (ThComp as TQRPrintable).Frame.DrawLeft:=FieldByName('Frame.DrawLeft').AsBoolean;
                   if not fieldByname('Frame.DrawTop').IsNULL
                   then     (ThComp as TQRPrintable).Frame.DrawTop:=FieldByName('Frame.DrawTop').AsBoolean;
                   if not fieldByname('Frame.DrawRight').IsNULL
                   then     (ThComp as TQRPrintable).Frame.DrawRight:=FieldByName('Frame.DrawRight').AsBoolean;
                   if not fieldByname('Frame.Width').IsNULL
                   then     (ThComp as TQRPrintable).Frame.Width:=FieldByName('Frame.Width').AsInteger;
                   if not fieldByname('Frame.Style').IsNULL
                   then     (ThComp as TQRPrintable).Frame.Style:=TPenStyle(FieldByName('Frame.Style').AsInteger);

                   if Values['BRUSH.COLOR']<>''
                   then (ThComp as TQrPrintable).Brush.Color:=TColor(getint(Values['BRUSH.COLOR']));

                   if Values['BRUSH.STYLE']<>''
                   then (ThComp as TQrPrintable).Brush.Style:=TBrushStyle(GetInt(Values['BRUSH.STYLE']));

                   if (ThComp is TQRCustomlabel) then begin
                     if not FieldByname('Color').IsNull
                     then (ThComp as TQRCustomLabel).Color:=TColor(FieldByname('Color').AsInteger);
                     if not FieldByname('Alignment').IsNull
                     then (ThComp as TQRCustomLabel).Alignment:=TAlignment(FieldByname('Alignment').AsInteger);
                     if not FieldByname('AutoSize').IsNull
                     then (ThComp as TQRCustomLabel).AutoSize:=FieldByname('AutoSize').AsBoolean;
                     if not FieldByname('Stretch').IsNull
                     then (ThComp as TQRCustomLabel).AutoStretch:=FieldByname('Stretch').AsBoolean;

                     if not FieldByname('Font.Charset').IsNull
                     then (ThComp as TQRCustomLabel).Font.Charset:=TFontCharSet(FieldByname('Font.Charset').AsInteger);

                     if not FieldByname('Font.Color').IsNull
                     then (ThComp as TQRCustomLabel).Font.Color:=TColor(FieldByname('Font.Color').AsInteger);

                     if not FieldByname('Font.Height').IsNull
                     then (ThComp as TQRCustomLabel).Font.Height:=FieldByname('Font.Height').AsInteger;

                     if not FieldByname('Font.Name').IsNull
                     then (ThComp as TQRCustomLabel).Font.Name:=FieldByname('Font.Name').AsString;

                     if not FieldByname('Font.Pitch').IsNull
                     then (ThComp as TQRCustomLabel).Font.Pitch:=TFontPitch(FieldByname('Font.Pitch').AsInteger);

                     if not FieldByname('Font.Size').IsNull
                     then (ThComp as TQRCustomLabel).Font.Size:=FieldByname('Font.Size').AsInteger;


                     if not FieldByname('WordWrap').IsNull
                     then (ThComp as TQRCustomLabel).WordWrap:=FieldByname('WordWrap').AsBoolean;

                     ThFSt:=[];

                     if FieldByname('Font.Style.IsBold').AsBoolean then ThFst:=ThFST+[fsBold];

                     if FieldByname('Font.Style.IsItalic').AsBoolean then  ThFst:=ThFST+[fsItalic];

                     if FieldByname('Font.Style.IsUnderline').AsBoolean then  ThFst:=ThFST+[fsUnderLine];

                     if FieldByname('Font.Style.IsStrikeOut').AsBoolean  then ThFst:=ThFST+[fsStrikeOut];

                     (ThComp as TQRCustomLabel).Font.Style:=ThFST;

                     if thComp is TQRlabel then begin   // - Caption .   TqrCustomlabel
                       if not FieldByname('Transparent').IsNull
                       then (ThComp as TQRLabel).Transparent:=FieldByname('Transparent').AsBoolean;

                       if Values['CAPTION']<>''
                       then (ThComp as TQRlabel).Caption:=VALUes['CAPTION'];
                     end
                     else if thComp is TQRDBText then begin   // - Caption .   TqrCustomlabel
                       if not FieldByname('Transparent').IsNull
                       then (ThComp as TQRDBText).Transparent:=FieldByname('Transparent').AsBoolean;

                       if VALUES['MASK']<>''
                       then (ThComp as TQRDBText).MASK:=VALUES['MASK'];
                       if VALUES['FIELD']<>''
                       then (ThComp as TQRDBText).DataField:=VALUES['FIELD'];
                     end
                     else if thComp is TQRMemo then begin   // - Caption .   TqrCustomlabel
                       if not FieldByname('Transparent').IsNull
                       then (ThComp as TQRMemo).Transparent:=FieldByname('Transparent').AsBoolean;

                       ThFileName:=VALUES['LINES'];
                       SetDopparam(ThComp,'LINES',ThFileName);
                       if (ThFileName<>'') and FileExists(ThFileName) then
                           try
                             (ThComp as TQRMemo).LINES.clear;
                             (ThComp as TQRMemo).LINES.LoadFromFile(thfileName);
                           except
                             on E:exception do
                               bvMessError('   '+#13+
                                ''+e.Message);
                           end;
                     end
                     else if thComp is TQRExpr then begin
                       if not FieldByname('Transparent').IsNull
                       then (ThComp as TQRExpr).Transparent:=FieldByname('Transparent').AsBoolean;

                       if VALUES['MASK']<>''
                       then (ThComp as TQREXPR).MASK:=VALUES['MASK'];

                       if VALUES['EXPRESSION']<>''
                       then (ThComp as TQREXPR).Expression:=VALUES['EXPRESSION'];

                       if VALUES['RESETAFTERPRINT']<>''
                       then (ThComp as TQREXPR).ResetAfterPrint:=GetBool(VALUES['RESETAFTERPRINT']);

                     end
                     else if thComp is TQRSysData then begin
                       if not FieldByname('Transparent').IsNull
                       then (ThComp as TQRSysData).Transparent:=FieldByname('Transparent').AsBoolean;
                       if VALUES['TEXT']<>''
                       then (ThComp as TQRSysData).Text:=VALUES['TEXT'];
                       if VALUES['DATA']<>''
                       then (ThComp as TQRSysData).DATA:=TQRSysDataType(GetInt(VALUES['DATA']));
                     end

                   end
                   else if (ThComp is TQRCustomRichText) then begin
                     if not FieldByname('Font.Charset').IsNull
                     then (ThComp as TQRCustomRichText).Font.Charset:=TFontCharSet(FieldByname('Font.Charset').AsInteger);
                     if not FieldByname('Font.Color').IsNull
                     then (ThComp as TQRCustomRichText).Font.Color:=TColor(FieldByname('Font.Color').AsInteger);
                     if not FieldByname('Font.Height').IsNull
                     then (ThComp as TQRCustomRichText).Font.Height:=FieldByname('Font.Height').AsInteger;
                     if not FieldByname('Font.Name').IsNull
                     then (ThComp as TQRCustomRichText).Font.Name:=FieldByname('Font.Name').AsString;
                     if not FieldByname('Font.Pitch').IsNull
                     then (ThComp as TQRCustomRichText).Font.Pitch:=TFontPitch(FieldByname('Font.Pitch').AsInteger);
                     if not FieldByname('Font.Size').IsNull
                     then (ThComp as TQRCustomRichText).Font.Size:=FieldByname('Font.Size').AsInteger;
                     ThFSt:=[];
                     if FieldByname('Font.Style.IsBold').AsBoolean then ThFst:=ThFST+[fsBold];
                     if FieldByname('Font.Style.IsItalic').AsBoolean then  ThFst:=ThFST+[fsItalic];
                     if FieldByname('Font.Style.IsUnderline').AsBoolean then  ThFst:=ThFST+[fsUnderLine];
                     if FieldByname('Font.Style.IsStrikeOut').AsBoolean  then ThFst:=ThFST+[fsStrikeOut];
                     (ThComp as TQRCustomRichText).Font.Style:=ThFST;


                     if not FieldByname('Color').IsNull
                     then (ThComp as TQRCustomRichText).Color:=TColor(FieldByname('Color').AsInteger);
                     if not FieldByname('Alignment').IsNull
                     then (ThComp as TQRCustomRichText).Alignment:=TAlignment(FieldByname('Alignment').AsInteger);
                     if not FieldByname('Stretch').IsNull
                     then (ThComp as TQRCustomRichText).AutoStretch:=FieldByname('Stretch').AsBoolean;

                     if (ThComp is TQRRichText) then begin

                       ThFileName:=VALUES['LINES'];
                       SetDopParam(ThComp,'LINES',thFileName);
                       if (ThFileName<>'') and FileExists(ThFileName) then
                           try
                             (ThComp as TQRRichText).LINES.Clear;
                             (ThComp as TQRRichText).LINES.LoadFromFile(thfileName);
                           except
                             on E:exception do
                               bvMessError('   '+#13+
                                ''+e.Message);
                           end;
                     end;
                   end
                   else if (ThComp is TQRImage) then begin
                     if not FieldByname('Stretch').IsNull
                     then (ThComp as TQRImage).Stretch:=FieldByname('Stretch').AsBoolean;
                     if not FieldByname('AutoSize').IsNull
                     then (ThComp as TQRImage).AutoSize:=FieldByname('AutoSize').AsBoolean;

                     if Values['CENTER']<>''
                     then (ThComp as TQRIMAGE).CENTER:=GetBool(Values['CENTER']);


                     if Values['PICTURE']<>''
                     then begin
                       ThFileName:=Values['PICTURE'];
                       SetDopParam(ThComp,'PICTURE',ThFileName);
                       if FileExists(ThFileName) then
                         try
                           (ThComp as TQRIMAGE).Picture.LoadFromFile(ThFileName);
                         except
                         end;
                     end
                   end
                   else if (ThComp is TQRDBImage) then begin
                     if not FieldByname('Stretch').IsNull
                     then (ThComp as TQRDBImage).Stretch:=FieldByname('Stretch').AsBoolean;
                     if not FieldByname('AutoSize').IsNull
                     then (ThComp as TQRImage).AutoSize:=FieldByname('AutoSize').AsBoolean;

                     if VALUES['CENTER']<>''
                     then (ThComp as TQRDBImage).CENTER:=getbool(VALUES['CENTER']);

                     if VALUES['FIELD']<>''
                     then (ThComp as TQRDBIMAGE).DataField:=VALUES['FIELD'];
                   end
                   else if (ThComp is TQRShape) then begin
                     if VALUES['SHAPE']<>''
                     then (ThComp as TQRSHAPE).Shape:=TQRShapeType(GetInt(VALUES['SHAPE']));
                     if VALUES['PEN.COLOR']<>''
                     then (ThComp as TQRSHAPE).Pen.Color:=TColor(Getint(VALUES['PEN.COLOR']));
                     if VALUES['PEN.MODE']<>''
                     then (ThComp as TQRSHAPE).Pen.Mode:=TPenMode(getInt(VALUES['PEN.MODE']));
                     if VALUES['PEN.STYLE']<>''
                     then (ThComp as TQRSHAPE).Pen.style:=TPenStyle(GETInt(Values['PEN.STYLE']));
                     if VALUES['PEN.WIDTH']<>''
                     then (ThComp as TQRSHAPE).Pen.Width:=GEtInt(Values['PEN.WIDTH']);
                   end
                end
                else  if (ThComp is TQRBasePanel) then begin

                  if not fieldByname('Frame.Color').IsNULL
                  then     (ThComp as TQRBasePanel).Frame.Color:=TColor(FieldByName('Frame.Color').AsInteger);

                  if not fieldByname('Frame.DrawBottom').IsNULL
                  then     (ThComp as TQRBasePanel).Frame.DrawBottom:=FieldByName('Frame.DrawBottom').AsBoolean;
                  if not fieldByname('Frame.DrawLeft').IsNULL
                  then     (ThComp as TQRBasePanel).Frame.DrawLeft:=FieldByName('Frame.DrawLeft').AsBoolean;
                  if not fieldByname('Frame.DrawTop').IsNULL
                  then     (ThComp as TQRBasePanel).Frame.DrawTop:=FieldByName('Frame.DrawTop').AsBoolean;
                  if not fieldByname('Frame.DrawRight').IsNULL
                  then     (ThComp as TQRBasePanel).Frame.DrawRight:=FieldByName('Frame.DrawRight').AsBoolean;
                  if not fieldByname('Frame.Width').IsNULL
                  then     (ThComp as TQRBasePanel).Frame.Width:=FieldByName('Frame.Width').AsInteger;
                  if not fieldByname('Frame.Style').IsNULL
                  then     (ThComp as TQRBasePanel).Frame.Style:=TPenStyle(FieldByName('Frame.Style').AsInteger);

                  if (ThComp is TQuickRep) then begin
                     if not FieldByname('Font.Charset').IsNull
                     then (ThComp as TQuickRep).Font.Charset:=TFontCharSet(FieldByname('Font.Charset').AsInteger);
                     if not FieldByname('Font.Color').IsNull
                     then (ThComp as TQuickRep).Font.Color:=TColor(FieldByname('Font.Color').AsInteger);
                     if not FieldByname('Font.Height').IsNull
                     then (ThComp as TQuickRep).Font.Height:=FieldByname('Font.Height').AsInteger;
                     if not FieldByname('Font.Name').IsNull
                     then (ThComp as TQuickRep).Font.Name:=FieldByname('Font.Name').AsString;
                     if not FieldByname('Font.Pitch').IsNull
                     then (ThComp as TQuickRep).Font.Pitch:=TFontPitch(FieldByname('Font.Pitch').AsInteger);
                     if not FieldByname('Font.Size').IsNull
                     then (ThComp as TQuickRep).Font.Size:=FieldByname('Font.Size').AsInteger;
                     ThFSt:=[];
                     if FieldByname('Font.Style.IsBold').AsBoolean=true then ThFst:=ThFST+[fsBold];
                     if FieldByname('Font.Style.IsItalic').AsBoolean=true then  ThFst:=ThFST+[fsItalic];
                     if FieldByname('Font.Style.IsUnderline').AsBoolean=true then  ThFst:=ThFST+[fsUnderLine];
                     if FieldByname('Font.Style.IsStrikeOut').AsBoolean=true  then ThFst:=ThFST+[fsStrikeOut];
                     (ThComp as TQuickRep).Font.Style:=ThFST;
                  end
                  else if (ThComp is TQRCustomBand) then begin

                    if not FieldByname('Font.Charset').IsNull
                    then (ThComp as TQRCustomBand).Font.Charset:=TFontCharSet(FieldByname('Font.Charset').AsInteger);
                    if not FieldByname('Font.Color').IsNull
                    then (ThComp as TQRCustomBand).Font.Color:=TColor(FieldByname('Font.Color').AsInteger);
                    if not FieldByname('Font.Height').IsNull
                    then (ThComp as TQRCustomBand).Font.Height:=FieldByname('Font.Height').AsInteger;
                    if not FieldByname('Font.Name').IsNull
                    then (ThComp as TQRCustomBand).Font.Name:=FieldByname('Font.Name').AsString;
                    if not FieldByname('Font.Pitch').IsNull
                    then (ThComp as TQRCustomBand).Font.Pitch:=TFontPitch(FieldByname('Font.Pitch').AsInteger);
                    if not FieldByname('Font.Size').IsNull
                    then (ThComp as TQRCustomBand).Font.Size:=FieldByname('Font.Size').AsInteger;
                    if not FieldByname('Alignment').IsNull
                    then (ThComp as TQRCustomBand).Aligntobottom:=Boolean(FieldByname('Alignment').AsInteger);

                    ThFSt:=[];
                    if FieldByname('Font.Style.IsBold').AsBoolean then ThFst:=ThFST+[fsBold];
                    if FieldByname('Font.Style.IsItalic').AsBoolean then  ThFst:=ThFST+[fsItalic];
                    if FieldByname('Font.Style.IsUnderline').AsBoolean then  ThFst:=ThFST+[fsUnderLine];
                    if FieldByname('Font.Style.IsStrikeOut').AsBoolean  then ThFst:=ThFST+[fsStrikeOut];
                    (ThComp as TQRCustomBand).Font.Style:=ThFST;
                    if not FieldByname('Color').IsNull
                    then (ThComp as TQRCustomBand).Color:=TColor(FieldByname('Color').AsInteger);

                    if VALUES['FORCENEWCOLUMN']<>''
                    then (ThComp as TQRCustomBand).ForceNewColumn:=GetBool(VALUES['FORCENEWCOLUMN']);

                    if VALUES['FORCENEWPAGE']<>''
                    then (ThComp as TQRCustomBand).ForceNewPAGE:=GETBOOL(VALUES['FORCENEWPAGE']);

                    if VALUES['BANDTYPE']<>''
                    then (ThComp as TQRCustomBand).BandType:=TQRBandType(GETINT(VALUES['BANDTYPE']));
                  end;
                end;
             end;
           end;
           Next;
       end;

     end;
  finally
     free;
  end;
end;

procedure TRepoEdit.SaveReport;
var
//    BoolVal:boolean;
    i:integer;
    ThComp:TComponent;
begin

//  ThID:=-1;
  if Assigned(AppendObj) then begin
    AppendObj.free;
    AppendObj:=nil;
  end;
  IniCheck;
  DeleteSavedReport(false);
  with TaREPORT do begin
    SetKey;
    TarepNameForm.AsString:=CorrectName;
    TaRepNameComp.AsString:=ThReport.Name+VariantStr;
    if Gotokey then begin
        Edit;
        FieldByname('Enabled').AsBoolean:=Enabled;
//        Post;
    end
    else  begin
      insert;
      TaRepNameForm.AsString:=CorrectName;
      TaRepNameComp.AsString:=ThReport.Name+VariantStr;
      fieldByname('Enabled').AsBoolean:=Enabled;
//      post;
//      FlushBuffers;
    end;
  end;

  try
    if Enabled  then  with TStringList.Create do
    try
       SetText(pchar(TaRepValue.Value));

       Values['ZOOM']:= inttostr(ThReport.Zoom);

       Values['PAGE.BOTTOMMARGIN']:=floattostr(ThReport.PAGE.BOTTOMMARGIN);
       Values['PAGE.LEFTMARGIN']:=FloatToStr(ThReport.PAGE.LEFTMARGIN);
       Values['PAGE.TOPMARGIN']:=FloatToStr(ThReport.PAGE.TOPMARGIN);
       Values['PAGE.RIGHTMARGIN']:=floattostr(ThReport.PAGE.RIGHTMARGIN);

       Values['PAGE.COLUMNSPACE']:=floattostr(ThReport.PAGE.COLUMNSPACE);
       Values['PAGE.LENGTH']:=floatTostr(ThReport.PAGE.LENGTH);
       Values['PAGE.WIDTH']:=floattostr(ThReport.PAGE.WIDTH);
       Values['PAGE.ORIENTATION']:=setInt(ord(ThReport.PAGE.ORIENTATION));
       Values['PAGE.PAPERSIZE']:=inttostr(ORD(ThReport.PAGE.PAPERSIZE));
       Values['PAGE.RULER']:=SetBool(ThReport.PAGE.RULER);
       Values['PAGE.COLUMNS']:=inttostr(ThReport.PAGE.COLUMNS);
       Values['PRINTERSETTINGS.COPIES']:=inttostr(ThReport.PRINTERSETTINGS.COPIES);
       Values['PRINTERSETTINGS.FIRSTPAGE']:=inttostr(ThReport.PRINTERSETTINGS.FIRSTPAGE);
       Values['PRINTERSETTINGS.LASTPAGE']:=inttostr(ThReport.PRINTERSETTINGS.LASTPAGE);
       Values['PRINTERSETTINGS.OUTPUTBIN']:=inttostr(ORD(ThReport.PRINTERSETTINGS.OUTPUTBIN));
       Values['PRINTERSETTINGS.DUPLEX']:=SetBool(ThReport.PRINTERSETTINGS.Duplex);
       Values['PRINTIFEMPTY']:=SetBool(ThReport.PRINTIFEMPTY);
       Values['SNAPTOGRID']:=SetBool(ThReport.SNAPTOGRID);
       Values['UNITS']:=inttostr(ord(ThReport.Units));

       TaRepValue.Value:=Text;
       TaReport.Post;

       for i:=-1 to MainWin.ComponentCount-1 do with TaReport do begin
         if i=-1 then ThComp:=ThReport
         else if  (MainWin.Components[i] is tqrPrintable
                   or (MainWin.Components[i] is tqrBasePanel))
                  and not
                  ((pos('New_',MainWin.Components[i].Name)=1)
                   and (mainWin.components[i] is TWinControl)
                   and not Assigned((MainWin.Components[i] as TWinControl).PARENT))
         then  ThComp:=MainWin.Components[i]
         else thComp:=nil;

         if Assigned(thComp) then begin

           Setkey;
           TaRepNAMEFORM.AsString:=CorrectName;
           TaRepNAMECOMP.AsString:=ThComp.Name+VariantStr;
           if not Gotokey then begin
             insert;
             TaRepNAMEFORM.AsString:=CorrectName;
             TaRepNAMECOMP.AsString:=ThComp.Name+VariantStr;
           end
           else Edit;

           SetText(pchar(TaRepValue.Value));


           if Not (ThComp is TQuickRep) then begin
             FieldByName('TOP').AsInteger:=(ThComp as TCustomControl).Top;
             fieldByname('LEFT').AsInteger:=(ThComp as TCustomControl).LEFT;
             fieldByname('WIDTH').AsInteger:=(ThComp as TCustomControl).Width;
             fieldByname('HEIGHT').AsInteger:=(ThComp as TCustomControl).HEIGHT;
             fieldByname('ENABLED').AsBoolean:=(ThComp as TCustomControl).Enabled;
           end;

           if (pos('New_',ThComp.Name)=1) then begin                   //NewComponent
              values['TYPE']:=UpperCase(ThComp.ClassName);
              values['PARENT']:=UpperCase((ThComp as TWinControl).PARENT.NAME);
           end;

           if ThComp is TQrPrintable then begin
              fieldByname('Frame.Color').AsInteger:=ORD((ThComp as TQRPrintable).Frame.Color);
              fieldByname('Frame.DrawBottom').AsBoolean:=(ThComp as TQRPrintable).Frame.DrawBottom;
              fieldByname('Frame.DrawLeft').AsBoolean:=(ThComp as TQRPrintable).Frame.DrawLeft;
              FieldByName('Frame.DrawTop').AsBoolean:=(ThComp as TQRPrintable).Frame.DrawTop;
              FieldByName('Frame.DrawRight').AsBoolean:=(ThComp as TQRPrintable).Frame.DrawRight;
              FieldByName('Frame.Width').AsInteger:=(ThComp as TQRPrintable).Frame.Width;
              FieldByName('Frame.Style').AsInteger:=ORD((ThComp as TQRPrintable).Frame.Style);

              values['BRUSH.COLOR']:=Inttostr(ORD((ThComp as TQRPRINTABLE).Brush.Color));
              values['BRUSH.STYLE']:=Inttostr(ORD((ThComp as TQRPRINTABLE).Brush.STYLE));

              if (ThComp is TQRCustomlabel) then begin
                FieldByname('Color').AsInteger:=ORD((ThComp as TQRCustomLabel).Color);
                FieldByname('Alignment').AsInteger:=ORD((ThComp as TQRCustomLabel).Alignment);
                FieldByname('AutoSize').AsBoolean:=(ThComp as TQRCustomLabel).AutoSize;
                FieldByname('Stretch').AsBoolean:=(ThComp as TQRCustomLabel).AutoStretch;
                FieldByname('Font.Charset').AsInteger:=ORD((ThComp as TQRCustomLabel).Font.Charset);
                FieldByname('Font.Color').AsInteger:=ORD((ThComp as TQRCustomLabel).Font.Color);
                FieldByname('Font.Height').AsInteger:=(ThComp as TQRCustomLabel).Font.Height;
                FieldByname('Font.Name').AsString:=(ThComp as TQRCustomLabel).Font.Name;
                FieldByname('Font.Pitch').AsInteger:=ORD((ThComp as TQRCustomLabel).Font.Pitch);
                FieldByname('Font.Size').AsInteger:=(ThComp as TQRCustomLabel).Font.Size;
                FieldByname('WordWrap').AsBoolean:=(ThComp as TQRCustomLabel).WordWrap;
                FieldByname('Font.Style.IsBold').AsBoolean:=fsBold in (ThComp as TQRCustomLabel).Font.Style;
                FieldByname('Font.Style.IsItalic').AsBoolean:=fsItalic in (ThComp as TQRCustomLabel).Font.Style;
                FieldByname('Font.Style.IsUnderline').AsBoolean:=fsUnderLine in (ThComp as TQRCustomLabel).Font.Style;
                FieldByname('Font.Style.IsStrikeOut').AsBoolean:=fsStrikeOut in (ThComp as TQRCustomLabel).Font.Style;

                if thComp is TQRlabel then begin   // - Caption .   TqrCustomlabel
                  FieldByname('Transparent').AsBoolean:=(ThComp as TQRLabel).Transparent;
                  Values['CAPTION']:=(ThComp as TQRlabel).CAPTION;
                end
                else if thComp is TQRDBText then begin
                  FieldByname('Transparent').AsBoolean:=(ThComp as TQRDBText).Transparent;
                  Values['MASK']:=(ThComp as TQRDBText).MASK;
                  Values['FIELD']:=(ThComp as TQRDBTEXT).DATAField;
                end
                else if thComp is TQRMemo then begin
                  FieldByname('Transparent').asboolean:=(ThComp as TQRMemo).Transparent;
                  Values['LINES']:=GetDopParam(ThComp,'LINES');
                end
                else if thComp is TQRExpr then begin
                  FieldByname('Transparent').AsBoolean:=(ThComp as TQRExpr).Transparent;
                  Values['MASK']:=(ThComp as TQREXPR).MASK;
                  Values['EXPRESSION']:=(ThComp as TQREXPR).Expression;
                  VALUES['RESETAFTERPRINT']:= SetBool((ThComp as TQREXPR).ResetAfterPrint);
                end
                else if thComp is TQRSysData then begin
                  FieldByname('Transparent').AsBoolean:=(ThComp as TQRSysData).Transparent;
                  Values['TEXT']:=(ThComp as TQRSysData).Text;
                  Values['DATA']:=IntToStr(ORD((ThComp as TQRSysData).DATA));
                end

              end
              else if (ThComp is TQRCustomRichText) then begin
                FieldByname('Font.Charset').AsInteger:=ORD((ThComp as TQRCustomRichText).Font.Charset);
                FieldByname('Font.Color').AsInteger:=ORD((ThComp as TQRCustomRichText).Font.Color);
                FieldByname('Font.Height').AsInteger:=(ThComp as TQRCustomRichText).Font.Height;
                FieldByname('Font.Name').AsString:=(ThComp as TQRCustomRichText).Font.Name;
                FieldByname('Font.Pitch').AsInteger:=ORD((ThComp as TQRCustomRichText).Font.Pitch);
                FieldByname('Font.Size').AsInteger:=(ThComp as TQRCustomRichText).Font.Size;
                FieldByname('Font.Style.IsBold').AsBoolean:=fsBold in (ThComp as TQRCustomRichText).Font.Style;
                FieldByname('Font.Style.IsItalic').AsBoolean:=fsItalic in (ThComp as TQRCustomRichText).Font.Style;
                FieldByname('Font.Style.IsUnderline').AsBoolean:=fsUnderLine in (ThComp as TQRCustomRichText).Font.Style;
                FieldByname('Font.Style.IsStrikeOut').AsBoolean:=fsStrikeOut in (ThComp as TQRCustomRichText).Font.Style;

                FieldByname('Color').AsInteger:=ORD((ThComp as TQRCustomRichText).Color);
                FieldByname('Alignment').AsInteger:=ORD((ThComp as TQRCustomRichText).Alignment);
                FieldByname('Stretch').AsBoolean:=(ThComp as TQRCustomRichText).AutoStretch;


                if ThComp is TQRRichText then begin
                  Values['LINES']:=GetDopParam(ThComp,'LINES');
                end;

              end
              else if (ThComp is TQRImage) then begin
                FieldByname('Stretch').AsBoolean:=(ThComp as TQRImage).Stretch;
                FieldByname('AutoSize').AsBoolean:=(ThComp as TQRImage).AutoSize;
                Values['CENTER']:=SetBool((ThComp as TQRIMAGE).CENTER);
                Values['PICTURE']:=GetDopParam(ThComp,'PICTURE');
              end
              else if (ThComp is TQRDBImage) then begin
                FieldByname('Stretch').AsBoolean:=(ThComp as TQRDBImage).Stretch;
    //            FieldByname('AutoSize').AsBoolean:=(ThComp as TQRDBImage).AutoSie;

                Values['CENTER']:=SetBool((ThComp as TQRDBIMAGE).CENTER);
                Values['FIELD']:=(ThComp as TQRDBImage).DATAField;
              end
              else if (ThComp is TQRShape) then begin
                Values['SHAPE']:=inttostr(ord((ThComp as TQRSHAPE).SHAPE));
                Values['PEN.COLOR']:=inttostr(ord((ThComp as TQRSHAPE).Pen.Color));
                Values['PEN.MODE']:=inttostr(ord((ThComp as TQRSHAPE).Pen.MODE));
                Values['PEN.STYLE']:=inttostr(ord((ThComp as TQRSHAPE).Pen.Style));
                Values['PEN.WIDTH']:=inttostr((ThComp as TQRSHAPE).Pen.Width);
              end
           end
    ////////////////////
           else  if (ThComp is TQRBasePanel) then begin
              fieldByname('Frame.Color').AsInteger:=ORD((ThComp as TQRBasePanel).Frame.Color);
              fieldByname('Frame.DrawBottom').AsBoolean:=(ThComp as TQRBasePanel).Frame.DrawBottom;
              fieldByname('Frame.DrawLeft').AsBoolean:=(ThComp as TQRBasePanel).Frame.DrawLeft;
              FieldByName('Frame.DrawTop').AsBoolean:=(ThComp as TQRBasePanel).Frame.DrawTop;
              FieldByName('Frame.DrawRight').AsBoolean:=(ThComp as TQRBasePanel).Frame.DrawRight;
              FieldByName('Frame.Width').AsInteger:=(ThComp as TQRBasePanel).Frame.Width;
              FieldByName('Frame.Style').AsInteger:=ORD((ThComp as TQRBasePanel).Frame.Style);


             if (ThComp is TQuickRep) then begin
                FieldByname('Font.Charset').AsInteger:=ORD((ThComp as TQuickRep).Font.Charset);
                FieldByname('Font.Color').AsInteger:=ORD((ThComp as TQuickRep).Font.Color);
                FieldByname('Font.Height').AsInteger:=(ThComp as TQuickRep).Font.Height;
                FieldByname('Font.Name').AsString:=(ThComp as TQuickRep).Font.Name;
                FieldByname('Font.Pitch').AsInteger:=ORD((ThComp as TQuickRep).Font.Pitch);
                FieldByname('Font.Size').AsInteger:=(ThComp as TQuickRep).Font.Size;
                FieldByname('Font.Style.IsBold').AsBoolean:=fsBold in (ThComp as TQuickRep).Font.Style;
                FieldByname('Font.Style.IsItalic').AsBoolean:=fsItalic in (ThComp as TQuickRep).Font.Style;
                FieldByname('Font.Style.IsUnderline').AsBoolean:=fsUnderLine in (ThComp as TQuickRep).Font.Style;
                FieldByname('Font.Style.IsStrikeOut').AsBoolean:=fsStrikeOut in (ThComp as TQuickRep).Font.Style;
             end
             else if (ThComp is TQRCustomBand) then begin
               FieldByname('Font.Charset').AsInteger:=ORD((ThComp as TQRCustomBand).Font.Charset);
               FieldByname('Font.Color').AsInteger:=ORD((ThComp as TQRCustomBand).Font.Color);
               FieldByname('Font.Height').AsInteger:=(ThComp as TQRCustomBand).Font.Height;
               FieldByname('Font.Name').AsString:=(ThComp as TQRCustomBand).Font.Name;
               FieldByname('Font.Pitch').AsInteger:=ORD((ThComp as TQRCustomBand).Font.Pitch);
               FieldByname('Font.Size').AsInteger:=(ThComp as TQRCustomBand).Font.Size;
               FieldByname('Font.Style.IsBold').AsBoolean:=fsBold in (ThComp as TQRCustomBand).Font.Style;
               FieldByname('Font.Style.IsItalic').AsBoolean:=fsItalic in (ThComp as TQRCustomBand).Font.Style;
               FieldByname('Font.Style.IsUnderline').AsBoolean:=fsUnderLine in (ThComp as TQRCustomBand).Font.Style;
               FieldByname('Font.Style.IsStrikeOut').AsBoolean:=fsStrikeOut in (ThComp as TQRCustomBand).Font.Style;

               FieldByname('Alignment').AsInteger:=ORD((ThComp as TQRCustomBand).Aligntobottom);

               FieldByname('Color').AsInteger:=(ThComp as TQRCustomBand).Color;

               Values['FORCENEWCOLUMN']:=setBool((ThComp as TQRCustomBand).ForceNewColumn);
               Values['FORCENEWPAGE']:=setBool((ThComp as TQRCustomBand).ForceNewPage);
               Values['BANDTYPE']:=SetInt(ord((ThComp as TQRCustomBand).BandType));
             end;
           end;

           TaRepValue.Value:=Text;
           Post;
         end
       end; // for



    finally
      free
    end;
  finally
    if TaReport.State in [dsEdit,dsInsert] then TaReport.Post;
    TaReport.flushBuffers;
  end;
end;

function DeleteAllIndexes:boolean;
var i,IC:integer;
begin
  Result:=true;
  try
     IniCheck;
     if TableExists(TaReport) then begin
        tareport.Active:=false;
        tarEport.Exclusive:=true;
        tareport.Active:=true;
        tareport.indexDefs.update;
        ic:=tareport.IndexDefs.Count;
        for i:=IC-1 downto 0 do begin
           tarEport.IndexDefs.Update;
           taReport.DeleteIndex(TaReport.IndexDefs[i].Name);
        end;

        tareport.Active:=false;
        tarEport.Exclusive:=false;
     end;
  except
    Result:=false;
    raise;
  end
end;


function IniCheck:boolean;
var ThDir:string;

begin
  Result:=true;
  try
    if not Assigned(IniFile) then IniFile:=TRegIniFile.Create('Software\BV\'+StringReplace(Application.ExeName,'\','/',[rfReplaceAll]));

    if RepoEditPath='' then ThDir:=ExtractFilePath(Application.ExeName)
    else ThDir:=RepoEditPath;

    if not assigned(TaReport) then begin
        TaReport:=TTable.Create(nil);

  //      RegisterPreviewClass(TbvPreviewInterface);

        with TaReport do begin

          TableName:=ThDir+DEfaultFileName;

          if not fileExists(TableName) then begin
             with FieldDefs do begin
                Clear;
                Add('NameForm',ftString, 30, true);
                Add('NameComponent',ftString, 70, false);
                Add('Enabled',ftBoolean, 0, false);
                Add('Color',ftInteger,0,false);
                Add('Left',ftInteger,0,false);
                Add('Width',ftInteger,0,false);
                Add('Top',ftInteger,0,false);
                Add('Height',ftInteger,0,false);
                Add('Alignment',ftInteger,0,false);
                Add('AutoSize',ftBoolean,0,false);
                Add('Stretch',ftBoolean,0,false);
                Add('Frame.Color',ftInteger,0,false);
                Add('Frame.DrawBottom',ftBoolean,0,false);
                Add('Frame.DrawLeft',ftBoolean,0,false);
                Add('Frame.DrawRight',ftBoolean,0,false);
                Add('Frame.DrawTop',ftBoolean,0,false);
                Add('Frame.Width',ftInteger,0,false);
                Add('Frame.Style',ftInteger,0,false);
                Add('Font.Charset',ftInteger,0,false);
                Add('Font.Color',ftInteger,0,false);
                Add('Font.Height',ftInteger,0,false);
                Add('Font.Name',ftString,30,false);
                Add('Font.Pitch',ftInteger,0,false);
                Add('Font.Size',ftInteger,0,false);
                Add('Font.Style.IsBold',ftBoolean,0,false);
                Add('Font.Style.IsItalic',ftBoolean,0,false);
                Add('Font.Style.IsUnderline',ftBoolean,0,false);
                Add('Font.Style.IsStrikeOut',ftBoolean,0,false);
                Add('Transparent',ftBoolean,0,false);
                Add('WordWrap',ftBoolean,0,false);
                Add('NotFrontBack',ftInteger,0,false); // 0- ./1-/2-Back
                add('Value',ftMemo,20,false);
             end;

             with IndexDefs do begin
                Clear;
                 Add('KeyField', 'NameForm;NameComponent', [ixPrimary,ixUnique]);
             end;
             CreateTable;
          end;
          Open;
        end;

    end
    else begin
      if not TaReport.Active then TaReport.Open;
      taReport.IndexDefs.Update;
      if (taReport.IndexDefs.count<1) or
         not ((ixPrimary in TaReport.IndexDefs[0].Options) and (ixUnique in TaReport.IndexDefs[0].Options ))
      then begin
        taReport.Active:=false;
        Tareport.Exclusive:=true;
        taReport.AddIndex( 'IDPRIMARY','NAMEFORM;NAMECOMPONENT',[ixPrimary,ixUnique]);
        taReport.Active:=false;
        tarEport.Exclusive:=false;
        taReport.Active:=true;
      end;
    end;

//    TaRepNameForm:=taReport.fieldByName('NAMEFORM') as tStringField;
//    TaRepNameComp:=taReport.Fieldbyname('NameComponent') as TStringField;
//    TaRepValue:=TaReport.FieldByname('Value') as TMemoField;
  except
    Result:=false;
    raise
  end;
end;

procedure TRepoEdit.Edit;
//var //i:integer;
//    ThComp:TComponent;
//    ThEditlabel:TEditlabel;
//    CompC:integer;
begin
//  ThEditLabel:=nil;

  if not Assigned(ThPanel) then begin
    ThPanel:=TPanelForm.Create(Self);
    ThPanel.PanelTop.Parent:=ThForm;
    thPanel.panelTop.Align:=alTop;
    ThPanel.BtnParam.OnClick:=BtnParamClick;
    ThPanel.BtnSave.OnClick:=BtnSaveClick;
    ThPanel.BtnCancel.OnClick:=BtnCancelClick;
    ThPanel.BtnSeeAll.OnClick:=BtnSeeAllClick;
    ThPanel.BtnChangeName.OnClick:=BtnChangeNameClick;
    ThPanel.SetEnabledBV(Enabled);
    thPanel.OnClose:=thFormclose;
  end;

//  ThPopup:=nil;

  ThPopupmenu:=TPopupMenu.Create(Self.Owner);
  ThPopupmenu.Name:=REPORTPOPUPNAME;
//  (THPopupmenu as TPopupMenu).style:=msBtnRaised;
  ThPopupmenu.AutoPopup:=true;
  ThPopupmenu.OnPopup:=OnShowPopup;
  ThPopupmenu.Items.Add(TMenuItem.Create(ThPopupmenu));
  with ThPopupmenu.Items[enableditemnum] do begin
    Caption:='';
    OnClick:=OnEnabledItemClick;
  end;

  ThPopupmenu.Items.Add(TMenuItem.Create(ThPopupmenu));
  with ThPopupmenu.Items[Deleteitemnum-1] do begin
    Caption:='-';
  end;
  ThPopupmenu.Items.Add(TMenuItem.Create(ThPopupmenu));
  with ThPopupmenu.Items[Deleteitemnum] do begin
    Caption:='';
    OnClick:=OnDeleteItemClick;
  end;

  ThPopupmenu.Items.Add(TMenuItem.Create(ThPopupmenu));
  with ThPopupmenu.Items[Propertyitemnum-1] do begin
    Caption:='-';
  end;
  ThPopupmenu.Items.Add(TMenuItem.Create(ThPopupmenu));
  with ThPopupmenu.Items[Propertyitemnum] do begin
    Caption:='..';
    OnClick:=OnPropertyItemClick;
  end;

  SetEvents;
  TForm(thReport).OnDblClick := DblClickHandler;
  Tform(thReport).OnMouseUp := MouseUpHandler;
  Tform(thReport).OnMouseDown := MouseDownHandler;
  Tform(thReport).OnMouseMove := MousemoveHandler;
//  Tform(thReport).OnPaint := paintHandler;
//  thForm.OnPaint := paintHandler;

  ThPanel.OldOnClose:=ThForm.OnClose;
  ThForm.OnClose:=ThPanel.ThOnClose;

  ThForm.WindowState:=wsMaximized;
  ThForm.HorzScrollBar.Position:=0;
  ThForm.VertScrollBar.Position:=0;
  ThPanel.Top:=ThForm.Height-ThPanel.Height-50;
  ThPanel.Left:=50;
//  ThPanel.Visible:=true;
  ThPanel.Visible:=false;
  thPanel.PanelTop.Visible:=true;
  thReport.Top:=0;
  thReport.left:=0;

  if Assigned(threport.dataSet)
  then thform.Caption:=thForm.Caption+' (: '+ThReport.DataSet.Name+')';

//  ThForm.ShowModal;

  if not Assigned(thStatusbar) then  thStatusbar:=TStatusBar.Create(self);
  thStatusbar.parent:=thForm;
  thStatusbar.SimplePanel:=false;
  thStatusbar.Panels.Clear;
  thStatusbar.Panels.Add;
  thStatusbar.Panels.Add;
  thStatusbar.Panels[0].Width:=70;
  thStatusbar.Panels[0].Alignment:=taCenter;

  IsEditing:=true;


  if not ((Application.mainForm.formstyle<>fsMDIForm)
          and (PreviewUnit.previewFormStyle=fsMDIChild))
  then  thForm.FormStyle:=PreviewUnit.PreviewFormStyle; // self.PreviewStyle;
  ThForm.Show;
  repeat
    Application.handleMessage;
  until not IsEditing
        or Application.Terminated
        or not thForm.HandleAllocated
        or not thform.Visible;

  if Assigned(thPanel) then thPanel.OnDestroy(thPanel);
  if Assigned(ThPopupmenu) then ThPopupmenu.Free;
end;

procedure TRepoEdit.BtnParamClick(Sender: TObject);
begin
  EdF:=TEditForm.Create(Application);
  (EdF as TEditForm).ThComp:=ThReport;
  (EdF as TEditForm).ThRepEdit:=Self;
  EdF.ShowModal;
  EdF.Free;
  EdF:=nil;
  application.processmessages;
end;

procedure TRepoEdit.BtnChangeNameClick(Sender: TObject);
var
    ThSTr:TStringlist;
begin
  ThStr:=tstringList.Create;
  try
    TaReport.SetKey;
    TaRepNameForm.AsString:=CorrectName;
    TaRepNameComp.asString:=ThReport.Name+VariantStr;
    if not TaReport.Gotokey then begin
      bvMessError('      !');
    end
    else begin
      ThStr.SetText(pchar(TaRepValue.value));

      with (TgetnameForm.Create(Self)) do
      try
           EditName.Text:=ThStr.Values['VariantName'];
           if ShowModal=mrOk then begin
             if ThStr.Values['VariantName']<>EditName.Text
             then begin
               ThStr.Values['VariantName']:=EditName.Text;
               TaReport.edit;
               TaRepValue.Value:=Thstr.Text;
               TaReport.Post;
               taReport.FlushBuffers;
             end
           end
      finally
           free;
      end;
    end;
  finally
    ThStr.Free;
  end;
end;

procedure TRepoEdit.BtnSaveClick(Sender: TObject);
var ThF:TSaveVarConfirmForm;
    OldVar,ThVar,ThMaxVar,i:integer;
    ThName,ThVarName,Str:string;
    NewVarF:TNewVariantForm;
begin
  ThF:=TSaveVarConfirmForm.create(self);
  try       

    ThF.EditCurrentVariant.Clear;
    //////////////////////////

    with TaReport do begin
       First;
       locate('NameForm',CorrectName,[]);
//       Setkey;
//       FieldByname('NAMEFORM').AsString:=CorrectName;
//       Gotokey;
       while not EOF and (TaRepNameForm.asString=CorrectName) do begin

           ThName:=TaRepNameComp.AsString;
           ThVar:=0;
           ThVarname:='';
           if pos(':',Thname)<>0 then begin
             ThVar:=strtoint(copy(ThName,pos(':',Thname)+1,10));
             ThName:=copy(ThName,1,pos(':',Thname)-1);
           end;

           if Self.ThReport.Name=ThName then with TStringList.Create
           do
           Try
             SetText(pchar(TaRepValue.value));
             ThVarName:=Values['VariantName'];
             if ThVarName='' then ThVarName:=DefaultVariantName;
             ThF.EditCurrentVariant.Items.Add(inttostr(ThVar)+':'+ThVarName);
           finally
             free;
           end;


          Next;
       end;
    end;

    if ThF.EditCurrentVariant.Items.Count=0 then begin
          ThF.EditCurrentVariant.Items.Add(DefaultVariantName);
          ThF.EditCurrentVariant.ItemIndex:=0;
    end
    else begin
       ThF.EditCurrentVariant.ItemIndex:=0;
       for ThVar:=0 to ThF.EditCurrentVariant.Items.Count-1 do
       begin
         ThVarName:=ThF.EditCurrentVariant.Items[thVar];
         if (ThVarName=DefaultVariantName)
            and (self.CurrentVariant=0)
            or
            (pos(':',ThVarName)<>0)
            and (strtoint(copy(ThVarName,1,pos(':',Thvarname)-1))=self.CurrentVariant)
         then begin
            ThF.EditCurrentVariant.ItemIndex:=ThVar;
            break;
         end;
       end;
    end;

    OldVar:=ThF.EditCurrentVariant.ItemIndex;

    ThF.ShowModal;

    if ThF.ModalResult in [mrOk,mrRetry] then begin
      if ThF.ModalResult=mrOk then begin
        if OldVar<>ThF.EditCurrentVariant.ItemIndex then begin
          if GetConfirmSmall(' '+ThF.EditCurrentVariant.text+#13
                        +' !')=mrOk
          then with taReport do begin
//            CheckDefaults;
//////
            First;
            Locate('NameForm',CorrectName,[]);
            Str:=copy(ThF.EditCurrentVariant.text,1,pos(':',ThF.EditCurrentVariant.text)-1);
            while not eof and (FieldByName('NameForm').AsString=CorrectName) do begin
              if (pos(':',FieldByName('NameComponent').AsString)=0)
                 and ((Str='') or (strtoint(Str)=0))
                 or
                 (pos(':',FieldByName('NameComponent').AsString)>0)
                 and (pos(':'+Str,FieldByName('NameComponent').AsString)>0)
              then begin
                Delete;
              end
              else Next;
            end;
//////
            OldVar:=ThF.EditCurrentVariant.ItemIndex;
          end;
        end;
        if OldVar=ThF.EditCurrentVariant.ItemIndex then begin
          ThVarName:=ThF.EditCurrentVariant.Text;
          if ThVarName=defaultVariantName then self.CurrentVariant:=0
          else begin
             Self.CurrentVariant:=strtoint(copy(ThVarName,1,pos(':',ThVarname)-1));
          end;



          SaveReport;
//          MessageDlg(' !',mtInformation,[mbOk],0);
        end;
      end
      else begin
        ThMaxVar:=0;
        for ThVar:=0 to ThF.EditCurrentVariant.Items.Count-1 do
        begin
          ThVarName:=ThF.EditCurrentVariant.Items[thVar];
          if (pos(':',ThVarName)<>0)
          then begin
             i:=strtoint(copy(ThVarName,1,pos(':',Thvarname)-1));
             if i>ThMaxVar then ThMaxVar:=i;
          end;
        end;
        inc(ThMaxVar);

        NewVarF:=TNewVariantForm.Create(Self);
        try
          NewVarF.EditNomer.text:=inttostr(ThMaxVar);
          NewVarF.EditName.text:=' '+inttostr(ThMaxVar);
          newVarF.ShowModal;
          if newVarF.ModalResult=mrOk then
            try
              ThMaxVar:=strtoint(trim(newVarF.EditNomer.Text));
              ThVarName:=newVarF.EditName.Text;

//              ThID:=-1;
              IniCheck;
              with TaReport do begin
                SetKey;
                FieldByname('NameForm').AsString:=CorrectName;

                i:=Self.CurrentVariant; //    VariantStr
                Self.CurrentVariant:=ThMaxVar;
                FieldByName('NameComponent').AsString:=ThReport.Name+VariantStr;
                Self.CurrentVariant:=i;

                if Gotokey then begin
                    raise bvVarExistsException.Create('   !  !');
                end
                else  begin
                  insert;
                  FieldByname('NameForm').AsString:=CorrectName;

                  i:=Self.CurrentVariant;
                  Self.CurrentVariant:=ThMaxVar;
                  FieldByName('NameComponent').AsString:=ThReport.Name+VariantStr;
                  Self.CurrentVariant:=i;

                  fieldByname('Enabled').AsBoolean:=Enabled;
                  TaRepValue.Value:='VariantName='+ThVarName;
                  post;
                end;
              end;


              OldVar:=thMaxVar;
//              CheckDefaults;
              Self.CurrentVariant:=ThMaxVar;
            except
              on e:bvVarExistsException
              do   bvMessError(e.Message)
              else bvMessError('  .  !');
            end;
        finally
          NewVarF.free;
        end;

        if OldVar=ThMaxVar then begin
          SaveReport;
//          MessageDlg(' !',mtInformation,[mbOk],0);
        end;
      end;

    end;

  finally
    ThF.free;
  end;
end;


procedure TRepoEdit.BtnCancelClick(Sender: TObject);
begin
  ThForm.Close;
  IsEditing:=false;
end;


procedure TRepoEdit.BtnSeeAllClick(Sender: TObject);
var ThF:TSeeAllForm;
    ThComp:TComponent;
begin
  ThF:=TSeeAllForm.Create(Self);
  ThF.ThEditor:=self;
  ThF.ShowModal;
  ThComp:=ThF.UserVibor;
  ThF.Free;
  if (ThComp<>nil) and assigned(tform(thcomp).ondblClick)
  then begin
      EdF:=TEditForm.Create(Application);

      (EdF as TEditForm).ThComp:=thcomp;

      (EdF as TEditForm).ThRepEdit:=Self;

      EdF.ShowModal;
      threport.Repaint;
      EdF.Free;
      EdF:=nil;
  end;
end;

procedure TRepoEdit.Execute;
begin
  DoReport;
end;

function TRepoEdit.DoReport(NeedFree:boolean=false):integer;
begin
  Result:=DoReportBtn(0,NeedFree);
end;

function TRepoEdit.DoReportBtn(Btn:integer;NeedFree:boolean=false):integer;
                    // 0-DoReport,1- 1 ,2-...
                    //procedure TRepoEdit.DoReport;
var ThName:string;
    ThVar:integer;
    ThVarName:string;
    LastCount,LastVarNum:integer;
    Res:TModalResult;
    InOnePaper,CheckLoad:boolean;
    thStInd:integer;
    thConfirmForm:TVarConfirmForm;
    i:integer;
//    OldPreviewFormStyle:TFormStyle;
begin
  Result:=0;
  Screen.Cursor:=crHourglass;

//  OldPreviewFormStyle:=PreviewUnit.PreviewFormStyle;
  IniCheck;

  thStInd:=IniFile.ReadInteger(PreviewUnit.RegSectionName,PreviewUnit.RegParamName,-1);
  if thstInd<>-1 then begin
      if thStInd=0 then PreviewUnit.PreviewFormStyle:=fsNormal
      else if thStInd=1 then PreviewUnit.PreviewFormStyle:=fsStayOnTop
      else PreviewUnit.PreviewFormStyle:=fsMDIChild;
  end;

  ThConfirmForm:= TVarConfirmForm.Create(application); //Tvarconfirmform(tform.create(Application)); //
  try

    ThConfirmForm.EditCurrentVariant.Clear;
    //////////////////////////

    IniCheck;


    with TaReport do begin
      lastcount:=1;
      LastVarNum:=0;
      InOnePaper:=false;
      CheckLoad:=false;

      SetKey;
      tarepNameForm.AsString:=CorrectName;
      taRepNameComp.AsString:='-Copyes';  //width:count; height:variant
      if GotoKey then begin
        LastCount:=FieldByName('Color').AsInteger; //    ?
        if Lastcount<=0 then LastCount:=1;
      end;

      SetKey;
      tarepNameForm.AsString:=CorrectName;
      taRepNameComp.AsString:='-VarNumber';
      if GotoKey then begin
        LastVarNum:=FieldByName('Color').AsInteger;
        if LastVarNum<0 then LastVarNum:=1;
      end;

      SetKey;
      tarepNameForm.AsString:=CorrectName;
      taRepNameComp.AsString:='-InOnePaper';
      if GotoKey then begin
        InOnePaper:=FieldByName('AutoSize').AsBoolean;
      end;

      SetKey;
      tarepNameForm.AsString:=CorrectName;
      taRepNameComp.AsString:='-CheckLoad';
      if GotoKey then begin
        CheckLoad:=FieldByName('AutoSize').AsBoolean;
      end;

    end;

    ThConfirmForm.SpinEditCount.Value:=LastCount;

    THconfirmForm.CheckinonePaper.Checked:=InOnePaper;
    thConfirmForm.CheckLoad.Checked:=CheckLoad;

     with TaReport do begin
       First;
       locate('NameForm',CorrectName,[]);
//       Setkey;
//       FieldByname('NAMEFORM').AsString:=CorrectName;
//       Gotokey;
       while not EOF and (Fieldbyname('NAMEFORM').asString=CorrectName) do begin

           ThName:=FieldByname('NAMECOMPONENT').AsString;
           ThVar:=0;
           ThVarname:='';
           if pos(':',Thname)<>0 then begin
             ThVar:=strtoint(copy(ThName,pos(':',Thname)+1,10));
             ThName:=copy(ThName,1,pos(':',Thname)-1);
           end;

           if Self.ThReport.Name=ThName then with TStringList.Create do
           try
             SetText(pchar(taRepValue.Value));
             ThVarName:=Values['VariantName'];
             if ThVarName='' then ThVarName:=DefaultVariantName;
             ThConfirmForm.EditCurrentVariant.Items.Add(inttostr(ThVar)+':'+ThVarName);
           finally
             free
           end;
          Next;
       end
     end;

     if ThConfirmForm.EditCurrentVariant.Items.Count=0 then begin
          ThConfirmForm.EditCurrentVariant.Items.Add(DefaultVariantName);
          ThConfirmForm.EditCurrentVariant.ItemIndex:=0;
     end
     else begin
       ThConfirmForm.EditCurrentVariant.ItemIndex:=0;
       for ThVar:=0 to ThConfirmForm.EditCurrentVariant.Items.Count-1 do
       begin
         ThVarName:=ThConfirmForm.EditCurrentVariant.Items[thVar];
         if (pos(inttostr(LastVarNum)+':',ThVarname)<>0)
         then begin
            ThConfirmForm.EditCurrentVariant.ItemIndex:=ThVar;
            break;
         end;
       end;
     end;


    //////////////////////////

   Screen.Cursor:=crDefault;


//   if Self.previewStyle<>fsMDIForm then begin
//     thConfirmForm.BtnStyle.enabled:=false;
//   end;

    case Btn of
      1:   Res:=mrOk;
      2:   Res:=mrYes;
      3:   Res:=mrRetry;
      4:   Res:=mrCancel;
      else begin
         Res:=ThConfirmForm.ShowModal;
         if Res<>mrCancel then begin
            LastCount:=ThConfirmForm.SpinEditCount.Value;
            InOnePaper:=THconfirmForm.CheckinonePaper.Checked;
            CheckLoad:=thConfirmForm.CheckLoad.Checked;
         end
      end
    end;


    case PreviewUnit.PreviewFormstyle of
      fsNormal: thStInd:=0;
      fsStayOnTop: thStInd:=1;
      fsMDIChild: thStInd:=2;
    end;
    IniFile.WriteInteger(PreviewUnit.RegSectionName,PreviewUnit.RegParamName,thStInd);

//    Application.ProcessMessages;
    Application.mainform.update;

    if Result=0 then
    case Res of
      mrOk :Result:=1;
      mrYes:Result:=2;
      mrRetry:Result:=3;
      mrCancel:Result:=4;
      else Result:=0;
    end;

//    if Self.PreviewStyle<>fsMDIForm then begin
//       OldPreviewFormStyle:=PreviewUnit.PreviewFormStyle;
//       PreviewUnit.PreviewFormStyle:=Self.PreviewStyle;
//    end;

    if Res in [mrOk,mrYes,mrRetry] then begin

      ThName:=ThConfirmForm.EditCurrentVariant.Items[ThConfirmForm.EditCurrentVariant.ItemIndex];
//      ThVar:=0;
      if ThName=DefaultVariantName then self.CurrentVariant:=0
      else if (pos(':',ThName)<>0) then begin
         Self.CurrentVariant:=strtoint(copy(ThName,1,pos(':',Thname)-1));
      end;

      //////////
      with TaReport do begin
        SetKey;
        TaRepNameForm.AsString:=CorrectName;
        TaRepNameComp.AsString:='-Copyes';  //width:count; height:variant
        if GotoKey then Edit
        else begin
          Insert;
          TaRepNameForm.AsString:=CorrectName;
          TaRepNameComp.AsString:='-Copyes';  //width:count; height:variant
        end;
        FieldByName('Color').AsInteger:=ThConfirmForm.SpinEditCount.Value;
        Post;

        SetKey;
        TaRepNameForm.AsString:=CorrectName;
        TaRepNameComp.AsString:='-VarNumber';  //width:count; height:variant
        if GotoKey then Edit
        else begin
           Insert;
           TaRepNameForm.AsString:=CorrectName;
           TaRepNameComp.AsString:='-VarNumber';  //width:count; height:variant
        end;
        FieldByName('Color').AsInteger:=Self.CurrentVariant;
        Post;

        SetKey;
        TaRepNameForm.AsString:=CorrectName;
        TaRepNameComp.AsString:='-InOnePaper';  //width:count; height:variant
        if GotoKey then Edit
        else begin
           Insert;
           TaRepNameForm.AsString:=CorrectName;
           TaRepNameComp.AsString:='-InOnePaper';  //width:count; height:variant
        end;
        FieldByName('AutoSize').Asboolean:=thConfirmForm.CheckInOnePaper.checked;
        Post;

        SetKey;
        TaRepNameForm.AsString:=CorrectName;
        TaRepNameComp.AsString:='-CheckLoad';  //width:count; height:variant
        if GotoKey then Edit
        else begin
           Insert;
           TaRepNameForm.AsString:=CorrectName;
           TaRepNameComp.AsString:='-CheckLoad';  //width:count; height:variant
        end;
        FieldByName('AutoSize').Asboolean:=thConfirmForm.CheckLoad.checked;
        Post;
      end;
      //////////

      if enabled then RestoreReport;

      if (Res in [mrOk,mrYes]) or (REs=mrRetry) and CheckLoad then begin
        CheckData;
      end;

      if Res in [mrOk,mrYes] then begin

        if Assigned(onNeedCount) then OnNeedCount(Self)
        else begin
          if not ThConfirmForm.CheckInOnePaper.checked
          then ThReport.PrinterSettings.Copies:=ThConfirmForm.SpinEditCount.Value
          else begin
             ThReport.PrinterSettings.Copies:=1;
          end
        end
      end;

{
      if (CurrentRepoEditPreview=ptRepoEdit4)
        and Assigned(FThReport)
        and not (csDesigning in self.ComponentState)
      then begin
//         FThReport.OnPreview:=PreviewProc;
      end;
//      else fthReport.OnPreview:=nil;
}
      application.processMessages;

      if assigned(thForm) then  ThReport.ReportTitle:=thForm.caption;


      if thConfirmform.CheckInOnePaper.checked and (ThConfirmForm.SpinEditCount.Value>1)
         and (Res<>mrRetry)
      then
      with thConfirmform.QRCompositeReport do
//      with TBVQRCompositeReport.Create(thConfirmForm) do
      try
//        PrinterSettings.Orientation:=ThReport.PrinterSettings.Orientation;
//        QRPrinter.OnPreview:=PreviewProc;
//        FqrPrinter.OnPreview:=PreviewProc;
//        OnAddReports:=thConfirmForm.QRCompositeReportAddReports;

        Options:=ThReport.Options;
        PrinterSettings.Orientation:=ThReport.Page.Orientation;// PrinterSettings.Orientation;
        PrinterSettings.Duplex:=thReport.PrinterSettings.Duplex;
        PrinterSettings.FirstPage:=threport.PrinterSettings.FirstPage;
        PrinterSettings.LastPage:=thReport.PrinterSettings.LastPage;
        PrinterSettings.OutputBin:=thReport.PrinterSettings.OutputBin;
        PrinterSettings.PaperSize:=thReport.page.PaperSize;

        if thReport.Page.Columns>1 then begin
           bvMess(' ,    '+#13
            +' ,    <>1. :-((');
           thReport.Page.Columns:=1;
        end;
//        ThConfirmForm.QRCompositeReport.PrinterSettin


        thConfirmForm.thRep:=Self.thReport;
        case Res of
          mrOk: Print;
          mrYes: Preview;
        end;
      finally
   //     TQuickRep(Reports[0]).Free;
      end
      else
      case Res of
        mrOk: ThReport.Print;
        mrYes: ThReport.Preview;
        mrRetry: Edit;
      end;
    end;

//    if Self.PreviewStyle<>fsMDIForm then begin
//       PreviewUnit.PreviewFormStyle:=OldPreviewFormStyle;
//    end;

    application.processMessages;

    for i:=0 to MainWin.ComponentCount-1 do begin
      if (Mainwin.Components[i] is TTAble)
      then
      if (trim((Mainwin.Components[i] as TTAble).tableName)<>'')
      then
      if ((pos('_QSQ',extractfilename(Uppercase((Mainwin.Components[i] as TTAble).tableName)))=1)
          or
         (pos('BV_',extractfilename(Uppercase((Mainwin.Components[i] as TTAble).tableName)))=1))
      then
      if TableExists(Mainwin.Components[i] as TTAble)
      then
      try
         (mainWin.Components[i] as ttable).active:=false;
         (Mainwin.Components[i] as TTAble).DeleteTable;
         (Mainwin.Components[i] as TTAble).TableName:='';
      except
      end
    end;

    application.processMessages;

  finally
    Screen.Cursor:=crDefault;
    ThConfirmForm.Free;
    ThConfirmForm:=nil;
    if NeedFree then begin
       MainWin.free;
    end;
  end;
end;



{function TRepoEdit.GetThCount:integer;
begin
  if Assigned(ThConfirmForm) then Result:=ThConfirmForm.SpinEditCount.Value
  else Result:=ThReport.PrinterSettings.Copies;
end;
}
function TRepoEdit.VariantStr :string;
begin
  if CurrentVariant=0 then Result:=''
  else  Result:=':'+inttostr(CurrentVariant);
end;


procedure TRepoEdit.OnShowPopup(Sender:TObject);
//var p:Tpoint;
begin
   with  Sender as TPopupMenu  do begin
//     GEtCursorPos(p);
//     POpupX:=p.x; PopupY:=p.y;
     if (PopupComponent is  TQuickRep)
     then items[enableditemNum].Checked:=self.enabled
     else  items[enableditemNum].Checked:=tcontrol(PopupComponent).enabled ; // as TCustomControl).Enabled;
//     items[enableditemNum].enabled:=not (PopupComponent is  TQuickRep);
     items[deleteitemnum].enabled:=(pos('New_',PopupComponent.Name)=1);
   end;
end;

procedure TRepoEdit.OnEnabledItemClick(Sender:TObject);
var i:integer;
begin
//   thName:=((Sender as TMenuItem).Owner as TPopupMenu).PopupComponent.Name;
//   thEnabled:=((Sender as TMenuItem).Owner as TPopupMenu).PopupComponent.enabled;
   if  ((Sender as TMenuItem).Owner as TPopupMenu).PopupComponent is TQuickRep
   then Self.Enabled:=not (Sender as TMenuItem).Checked
   else with   (((Sender as TMenuItem).Owner as TPopupMenu).PopupComponent as TwinControl) do
   begin
     Enabled:=not (Sender as TMenuItem).Checked;
     for i:=0 to ControlCount-1 do
       if Controls[i] is tEnabledLab then begin
          Controls[i].Visible:=not Enabled;
          break
       end;
     thReport.Repaint;
   end;
//   thEnabled:=((Sender as TMenuItem).Owner as TPopupMenu).PopupComponent.enabled;
end;

procedure TRepoEdit.OnDeleteItemClick(Sender:TObject);
//var isBand:boolean;
begin
   with   ThPopupMenu.PopupComponent do
   if pos('New_',Name)=1 then
   try
     if thpopupmenu.popupcomponent=selected
     then Selected:=nil;
     free;
     ThForm.Repaint;
   except
     on e:exception do bvMessError('   !'+#13+#13+
         ': '+e.Message)
     else raise
   end
end;

procedure TRepoEdit.OnPropertyItemClick(Sender:TObject);
var thC:tcontrol;
begin
//   dblclickhandler(((Sender as TMenuItem).Owner as TPopupMenu).PopupComponent);
  thC:=FindComp(Popupx,PopupY);
  EdF:=TEditForm.Create(Application);

  if assigned(thC) then begin
     (EdF as TEditForm).ThComp:=thc;
  end
  else (EdF as TEditForm).thcomp:=thReport;

  (EdF as TEditForm).ThRepEdit:=Self;

  EdF.ShowModal;

  threport.Repaint;
  EdF.Free;
  EdF:=nil;
end;


procedure TRepoEdit.SetDopParam(Sender:TComponent;ParamName,ParamValue:string);
var k:integer;
    ThDopParam:TDopParam;
begin
  for k:=0 to sender.ComponentCount-1 do begin
    if Sender.Components[k] is TDopParam
        and
        ((Sender.Components[k] as TDopParam).ParamName=ParamName)
    then begin
      (Sender.Components[k] as TDopParam).Value:=ParamValue;
      exit;
    end;
  end;

  ThDopParam:=TDopParam.Create(Sender);
  ThDopParam.ParamName:=ParamName;
  ThDopParam.Value:=ParamValue;
end;

function TRepoEdit.GetDopParam(Sender:TComponent;ParamName:string):string;
var k:integer;
begin
  for k:=0 to Sender.ComponentCount-1 do begin
    if Sender.Components[k] is TDopParam
        and
        ((Sender.Components[k] as TDopParam).ParamName=ParamName)
    then begin
      Result:=(Sender.Components[k] as TDopParam).Value;
      exit;
    end;
  end;
  Result:='';
end;

procedure TRepoEdit.SaveDopParams(Sender:TComponent;ParamList:TStringList);
var k:integer;
begin
  for k:=0 to Sender.ComponentCount-1 do begin
    if Sender.Components[k] is TDopParam
    then begin
      ParamList.Values[(Sender.Components[k] as TDopParam).ParamName]:=(Sender.Components[k] as TDopParam).Value;
    end;
  end;
end;


constructor TDopParam.Create(AOwner:TComponent);
begin
  inherited create(AOwner);
  ParamName:='';
  Value:='';
end;

function TRepoEdit.CorrectName:string;
begin
  if owner is TQuickRep then Result:=Owner.ClassName
  else if Owner<>nil then Result:=Owner.ClassName
  else Result:='';
end;

function TRepoEdit.GetMainWin:TComponent;
begin
  if ThReport.Owner=thForm then   ///   -   !
     Result:=ThForm
  else
     Result:=ThReport;    //  Report    .
end;


{
Procedure tRepoEdit.PreviewProc(Sender:TObject);
var ThPrinter:tqrPrinter;
begin
  if not (Sender is TQrPrinter)
  then ThPrinter:=nil
  else THPrinter:=(Sender as TqrPrinter);
  with TRepoEditPreview.CreatePreview(Self,ThPrinter) do
  try
     Show;
  finally
  end;
end;
}
procedure TRepoEdit.CheckData;
begin
   if Assigned(onNeedData) then
   with TREpMyWait.Create(' !') do
   try
     OnNeedData(Self);
   finally
     free
   end;
end;

function TRepoEdit.FindComp(x:integer=-1000000;y:integer=-1000000):TWinControl;
var p,p1:tpoint;
    thC,thC1:TWinControl;
begin
  if x=-1000000 then  GetCursorPos(p)
  else begin
     p:=point(x,y);
  end;
  p1:=thReport.Screentoclient(p);
  thC:=GetContr(p1,thReport);
  if assigned(thC) and (thC is tqrCustomBand)
  then
  begin
    p1:=thC.Screentoclient(p);
    thC1:=GetContr(p1,TWincontrol(thC));
    if Assigned(thC1) then thC:=thC1;
  end;

  REsult:=thC;
end;

function TRepoEdit.GetContr(const Pos: TPoint;ParComp:TWinControl): TwinControl;
var
  I: Integer;
  P: TPoint;
begin
  with parcomp do
  if Controlcount > 0 then
    for I := ControlCount - 1 downto 0 do
    begin
      Result := TWinControl(Controls[I]);
      with Result do
      begin
        P := Point(Pos.X - Left, Pos.Y - Top);
        if PtInRect(ClientRect, P) and
          ((csDesigning in ComponentState) and (Visible or
          not (csNoDesignVisible in ControlStyle)) or
          (Visible and
          (Perform(CM_HITTEST, 0, Longint(PointToSmallPoint(P))) <> 0))) then
          begin
            if (REsult is TRectLabel)
                 and Assigned(Selected)
            then begin
                 Result:=Selected;
            end;
            Exit;
          end
      end;
    end;
  Result := nil;
end;

procedure TRepoEdit.MouseMoveHandler(Sender : TObject; Shift : TShiftState; X, Y : integer);
var thC:TComponent;
    p:TPoint;
    aleft,atop,aright,abottom:integer;
begin
    p:=thReport.ScreenToClient(TControl(Sender).ClientToScreen(Point(X, Y)));
    SElf.thStatusBar.panels[0].Text:=inttostr(p.x{TControl(Sender).Left})+':'+inttostr(p.y{TControl(Sender).Top});

    if ssleft in shift then begin
//       if sender is TRectLabel then begin
//         p:=point(x,y);
//       end
//       else begin
//         p:=thReport.ScreenToClient(TControl(Sender).ClientToScreen(Point(X, Y)));

//        p:=(selected as tcontrol).ScreentoClient((sender as tcontrol).clienttoscreen(point(x,y)));
//       end;
       ALeft:=0;
       ATop:=0;
       ARight:=0;
       ABottom:=0;
       if assigned(thFrame) then begin
         if Sender is TRectLabel
         then begin
            case (Sender as TRectLabel).ID of
               rlTopLeft:
                  begin
                    ALeft:=-(p.x-thFrame.{CurrentRect.}BoundsRect.Left);
                    ATop:=-(p.y-thFrame.{CurrentRect.}BoundsRect.Top);
                  end;
               rlTop:
                  begin
                    ATop:=-(p.y-thFrame.{CurrentRect.}BoundsRect.Top);
                  end;
               rlTopRight:
                  begin
                    ARight:=(p.x-thFrame.{CurrentRect.}BoundsRect.right);
                    ATop:=-(p.y-thFrame.{CurrentRect.}BoundsRect.Top);
                  end;
               rlRight:
                  begin
                    ARight:=(p.x-thFrame.{CurrentRect.}BoundsRect.right);
                  end;
               rlBottomRight:
                  begin
                    ARight:=(p.x-thFrame.{CurrentRect.}BoundsRect.right);
                    ABottom:=(p.y-thFrame.{CurrentRect.}BoundsRect.Bottom);
                  end;
               rlBottom:
                  begin
                    ABottom:=(p.y-thFrame.{CurrentRect.}BoundsRect.bottom);
                  end;
               rlBottomLeft:
                  begin
                    ALeft:=-(p.x-thFrame.{CurrentRect.}BoundsRect.Left);
                    ABottom:=(p.y-thFrame.{CurrentRect.}BoundsRect.bottom);
                  end;
               else
                  begin
                    ALeft:=-(p.x-thFrame.{CurrentRect.}BoundsRect.Left);
                  end;
            end;
            thFrame.SizeFrame(Aleft,atop,aright,abottom);
            SetRectCoord(thFrame.{CurrentRect.}BoundsRect.Left,thFrame.{CurrentRect.}BoundsRect.Right,
                         thFrame.{CurrentRect.}BoundsRect.Top,thFrame.{CurrentRect.}BoundsRect.Bottom);
         end
         else thFrame.MoveFrame(-(p.x-thFrame.{CurrentRect.}BoundsRect.Left-OldX),-(p.y-thFrame.{CurrentRect.}BoundsRect.top-OldY));
       end;
    end
    else if assigned(AppendOBJ) then begin
      thC:=FindComp;
      if not (thC is tqrBasePanel)
         and not (thC is tqrPrintable)
      then Screen.cursor:=crNO
      else Screen.cursor:=crCross;
    end
end;

procedure TRepoEdit.MouseDownHandler(Sender : TObject; Button : TMouseButton; Shift : TShiftState; X, Y : integer);
var p:tpoint;
    thComp:TWinControl;
//    FirstClick:boolean;
begin
    if not CannotMouseDown then begin
      if Sender is TREctLabel then begin
         thComp:=Selected
      end
      else begin
         thComp:=FindComp;
         if not (Selected=thComp) then  Selected:=thComp;
      end;
    //  FirstClick:=thComp<>selected;
      if button=mbLeft then begin
        if assigned(selected)
        then  begin

          p:=(selected as tcontrol).ScreentoClient((sender as tcontrol).clienttoscreen(point(x,y)));

          OldX:=p.X;
          OldY:=p.Y;

          if not (sender is TRectLabel) then Screen.cursor:=crdrag;

          if assigned(thFrame) then begin
            thFrame.free;
            thframe:=nil;
          end;
    {      if not FirstClick then begin}
    //        HideRect;
            SetHints(False);
            thFrame:=tSelectedFrame.Create(threport);
            thFrame.showHint:=true;
            thFrame.parent:=selected;
            thFrame.{CurrentRect.}BoundsRect := CalcOffsetRect(tControl(Selected));
            thframe.PaintFrame;
    {      end}
        end
      end
      else if (button=mbright) and assigned(Appendobj)
      then begin
        AppendObj.free;
        AppendOBJ:=nil;
        Screen.cursor:=crdefault
      end
    end
    else CannotmouseDown:=false;
end;

procedure TRepoEdit.MouseUpHandler(Sender : TObject; Button : TMouseButton; Shift : TShiftState; X, Y : integer);
var thC:tcontrol;
    p:tpoint;
begin
    if (button=mbright) and not (SEnder is tRectLabel) then begin
      thC:=FindComp;
      if assigned(thc)
      then  thPopupMenu.PopupComponent:=thC
      else thpopupmenu.popupcomponent:=threport;
      p:=(sender as tcontrol).clienttoscreen(point(x,y));
      Popupx:=p.X;POpupY:=p.Y;
  //    p:=point(x,y);
      thpopupmenu.Popup(p.x,p.y);
    end
    else if (button=mbLeft)
         and Assigned(AppendOBj)
    then begin
      thC:=FindComp;
      if assigned(thc)
         and (thC is tqrcustomband)
      then begin
          AppendOBj.parent:=thC as TwinControl;
          AppendOBj.Left:=X;
          AppendOBj.Top:=Y;
          Selected:=AppendObj;
          AppendOBj:=nil;
          SEtEvents;
      end
    end
    else if (button=mbleft) and assigned(thFrame)
    then begin
      thFrame.PaintFrame;
  //    hideRect;
      SetOffsetCoord(Selected,thFrame.{CurrentRect.}BoundsRect);
      SetRectCoord;
      thFrame.free;
      thframe:=nil;
      ShowRect;
      SetHints(True);
    end;
  //  if assigned(Selected) then selected.repaint;
    if Assigned(thPanel) then thPanel.SetFontButtons;
    Screen.Cursor:=crDefault;
end;

procedure TREpoEdit.DblClickHandler(Sender:TObject);
var thC:tcontrol;
begin
  CannotMouseDown:=true;
  thC:=FindComp;
  EdF:=TEditForm.Create(Application);

  if assigned(thC) then begin
     (EdF as TEditForm).ThComp:=thc;
  end
  else (EdF as TEditForm).thcomp:=thReport;

  (EdF as TEditForm).threpedit:=Self;

//  Application.processmessages;
  EdF.ShowModal;
  threport.Repaint;
  EdF.Free;
  EdF:=nil;
end;

procedure TRepoEdit.SetEvents(AControl : TWinControl=nil);
var
  I : integer;
//  thCS:TControlStyle;
begin
  if AControl=nil then AControl:=ThReport;

  for I := 0 to AControl.ControlCount - 1 do
  if AControl.Controls[I] is TqrPrintable
     or (AControl.Controls[I] is TqrBasePanel)
  then
  with AControl do
  begin
//    TForm(Controls[I]).OnMouseDown := MouseDownHandler;
//    TForm(Controls[I]).OnClick := ClickHandler;
    TForm(Controls[I]).OnDblClick := DblClickHandler;

    with tEnabledLab.Create(Self) do begin
      left:=5;
      top:=5;
      parent:=TWinControl(AControl.Controls[i]);
      visible:=not parent.enabled;
    end;

    if Controls[i] is TQRLabel then          Controls[i].Hint:=''
    else  if Controls[i] is TQRDBText then   Controls[i].Hint:=''
    else if Controls[i] is TQRMemo then      Controls[i].Hint:=', .  '
    else if Controls[i] is TQRImage then     Controls[i].Hint:=', .  '
    else if Controls[i] is TQRDBImage then   Controls[i].Hint:=' - '
    else if Controls[i] is TQRShape then     Controls[i].Hint:=''
    else if Controls[i] is TQRExpr then      Controls[i].Hint:=' '
    else if Controls[i] is TQRSysData then   Controls[i].Hint:=' '
    else if Controls[i] is TQRBand then      Controls[i].Hint:='  '
    else if Controls[i] is TQRSubDetail then Controls[i].Hint:=' '
    else if Controls[i] is TQRRichText then  Controls[i].HInt:=' '
    else if Controls[i] is TQRDBRichText then Controls[i].Hint:=' ';

    if Controls[i] is TQRCustomRichText
    then begin
//     (Controls[i] as TQRCustomRichText).ComponentState:=(Controls[i] as TQRCustomRichText).ComponentState+[csDesigning];
    end;

    controls[i].showhint:=true;
//    TForm(Controls[I]).OnMouseMove := MouseMoveHandler;
    Tform(Controls[I]).OnMouseUp := MouseUpHandler;
    Tform(Controls[I]).OnMousedown := MousedownHandler;
    Tform(Controls[I]).OnMousemove := MousemoveHandler;
//    Tform(Controls[I]).OnPaint := PaintHandler;
//    TForm(Controls[I]).PopupMenu := thPopupMenu;
    if Controls[I] is TWinControl then SetEvents(TWinControl(Controls[I]));
  end;
end;

procedure TRepoEdit.Sethints(Value:boolean;AControl : TWinControl=nil);
var
  I : integer;
begin
  if AControl=nil then AControl:=ThReport;

  for I := 0 to AControl.ControlCount - 1 do
  if AControl.Controls[I] is TqrPrintable
     or (AControl.Controls[I] is TqrBasePanel)
  then
  with AControl do
  begin
    controls[i].showhint:=Value;
    if Controls[I] is TWinControl then SetHints(Value,TWinControl(Controls[I]));
  end;
end;



{
procedure TRepoEdit.PaintHandler(Sender : TObject);
begin
    if not (Sender as TCustomControl).Enabled
    then
    with thForm do begin
       Canvas.Pen.Color:=clRed;
       Canvas.pen.Width:=1;
       Canvas.pen.Style:=psSolid;
       Canvas.MoveTo((sender as tCustomControl).ClientRect.Left+1,(sender as tCustomControl).ClientRect.Top+1);
       canvas.LineTo((sender as tCustomControl).ClientRect.Right-1,(sender as tCustomControl).ClientRect.Bottom-1);
       Canvas.MoveTo((sender as tCustomControl).ClientRect.Right-1,(sender as tCustomControl).ClientRect.Top+1);
       canvas.LineTo((sender as tCustomControl).ClientRect.Left+1,(sender as tCustomControl).ClientRect.Bottom-1);
    end;
end;
}
procedure TRepoEdit.SetSelected(Value:TWinControl);
var iRect:TRectLab;
    ThLab:TRectlabel;
//    i:integer;
//    p:TPoint;
begin

  for iRect:=Low(ThRect) to High(ThRect) do
    if Assigned(ThRect[iRect]) then begin
         ThRect[iRect].Free;
         ThRect[iRect]:=nil;
    end;

  if Assigned(thFrame) then thFrame.free;
  thFrame:=nil;

  if Assigned(thEnabledLab) then thEnabledLab.free;

  FSelected:=Value;

  if assigned(thPanel) then begin
     thPanel.SetFontButtons;
     if assigned(FSelected)
     then thpanel.BtnMinus.enabled:=(pos('New_',FSElected.Name)=1);
  end;


  if assigned(Value) Then begin
    for iRect:=Low(ThRect) to High(ThRect) do begin
      if not Assigned(thREct[irect]) then begin
         ThLab:=TRectLabel.Create(self);
         ThLab.ID:=irect;
         ThRect[iRect]:=ThLab;
         thLab.visible:=false;
         ThLab.Width:=5;
         ThLab.Height:=5;
         ThLab.Parent:=  thREport; // TWinControl(Selected); //(Value as TWinControl); //.Parent;

         ThLab.OnMouseDown:=MouseDownHandler;
         thLab.OnMouseUp:=MouseUpHandler;
         thLab.OnMouseMove:=MouseMoveHandler;
      end;

//      thLab.visible:=false;

//      thLab.Color:=clBlack;
//      thlab.Brush.Color:=clBlack;
//      thLab.Visible:=true;


      case iRect of
        rlTopLeft:
           begin
             ThLab.Cursor:=crSizeNWSE;
           end;
        rlTop:
           begin
             ThLab.Cursor:=crSizeNS;
           end;
        rlTopRight:
           begin
             ThLab.Cursor:=crSizeNESW;
           end;
        rlRight:
           begin
             ThLab.Cursor:=crSizeWE;
           end;
        rlBottomRight:
           begin
             ThLab.Cursor:=crSizeNWSE;
           end;
        rlBottom:
           begin
             ThLab.Cursor:=crSizeNS;
           end;
        rlBottomLeft:
           begin
             ThLab.Cursor:=crSizeNESW;
           end;
        else
           begin
             ThLab.Cursor:=crSizeWE;
           end;
      end;
    end;



    SetRectCoord;
    ShowRect;
  end;
//  Repaint;
end;

{
procedure TRectLabel.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ssleft in Shift then begin
    OldX:=X;
    OldY:=Y;
  end;
  inherited;
end;
}
procedure TRepoEdit.SetRectCoord(thleft:integer=-1000000;thright:integer=-1000000;thtop:integer=-1000000;thbottom:integer=-1000000);
var iRect:TRectLab;
    p:tpoint;
    ThLab:TRectlabel;
    thW,thH:integer;
begin
    if assigned(Selected) then begin
//      if assigned(thFrame) then thframe.PaintFrame; // hide

      if thleft<>-1000000 then begin
        p:=point(thLeft,thTop);
      end
      else begin
        p:=point((selected as TControl).Left,(selected as TControl).Top);
        p:=(Selected as TControl).parent.ClientToScreen(p);
        p:=thReport.ScreenToClient(p);
      end;
//      thW:=(Selected as TWinControl).Width;
//      thH:=(selected as TWinControl).height;

      for iRect:=Low(thRect) to high(thRect)
      do if Assigned(thRect[iRect]) then begin
        ThLab:=ThRect[iRect];
//        thLab.BringToFront;
        if thright<>-1000000 then begin
          thW:=thright-thLeft;
          thH:=thBottom-thTop;
        end
        else begin
          thW:=(Selected as TControl).width;
          thH:=(Selected as TControl).height;
        end;


        case iRect of
          rlTopLeft:
             begin
               ThLab.Top:=p.y-2;
               ThLab.Left:=p.x-2;
             end;
          rlTop:
             begin
               ThLab.Top:=p.y-2;
               ThLab.Left:=p.x+thW div 2-2;
             end;
          rlTopRight:
             begin
               ThLab.Top:=p.y-2;
               ThLab.Left:=(p.x+thW)-2;
             end;
          rlRight:
             begin
               ThLab.Top:=p.y+thH div 2-2;
               ThLab.Left:=(p.x+thW)-2;
             end;
          rlBottomRight:
             begin
               ThLab.Top:=(p.y+thH)-2;
               ThLab.Left:=(p.x+thW)-2;
             end;
          rlBottom:
             begin
               ThLab.Top:=(p.y+thH)-2;
               ThLab.Left:=p.x+thW div 2-2;
             end;
          rlBottomLeft:
             begin
               ThLab.Top:=(p.y+thH)-2;
               ThLab.Left:=(p.x)-2;
             end;
          else
             begin
               ThLab.Top:=p.y+thH div 2-2;
               ThLab.Left:=(p.x)-2;
             end;
        end;
      end;
//      if assigned(thFrame) then thframe.PaintFrame;
    end;
end;


{
procedure TRectLabel.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited;
end;
}

procedure TRectLabel.paint;
begin
    Canvas.Brush.Color := clBlack;
    Canvas.Pen.Color := clBlack;
    Canvas.FillRect(ClientRect);
end;


procedure TRepoEdit.HideRect;
var i:tRectLab;
begin
  for i:=low(ThRect) to high(thRect)
  do if Assigned(thRect[i]) then thRect[i].visible:=false;
end;

procedure TRepoEdit.ShowRect;
var i:tRectLab;
begin
  for i:=low(ThRect) to high(thRect)
  do if Assigned(thRect[i]) then begin
    thRect[i].visible:=true;
//    thRect[i].Update
  end
end;

procedure TRepoEdit.UpdateSelected;
begin
end;

procedure TEnabledLab.paint;
begin
    canvas.pen.Color:=clRed;
    canvas.brush.Color:=clRed;
    Canvas.FillRect(ClientRect);
end;

procedure TEnabledLab.dblclickhandle(Sender:TObject);
begin
  Parent.Enabled:=not Parent.Enabled;
  Visible:=not Parent.enabled;
  paint;
end;

constructor TEnabledLab.create(AOwner:tComponent);
begin
  inherited;
  width:=5;
  height:=5;
end;

procedure TEnabledLab.Hinthandle;
begin
  if parent.enabled then  Hint:=''
  else Hint:='';
end;

constructor TSelectedFrame.Create(Owner:TComponent);
begin
  inherited;
//  Canvas:=TCanvas.Create;
//  Canvas.Handle:=(Owner as TWinControl).handle;
end;

destructor TSelectedFrame.destroy;
begin
//  Canvas.free;
  inherited
end;


procedure TSelectedFrame.paintFrame;
var
  AHandle : THandle;
begin
    AHandle := GetDCEx(TWinControl(Owner).Handle, 0, DCX_WINDOW  or DCX_PARENTCLIP);
    DrawFocusRect(AHandle, {CurrentRect.}BoundsRect);
    ReleaseDC(TWinControl(Owner).Handle, AHandle);
//   CAnvas.brush.Color:=clGray;
//   Canvas.Pen.Color:=clGray;
//   CAnvas.Pen.Width:=2;
//   CAnvas.fillRect(BoundsREct);
//   Canvas.FrameRect(BoundsRect);
end;

procedure TSelectedFrame.MoveFrame(ALeft, AUp : integer);
var thRect:TRect;
begin
  {if FState = fsFrame then} PaintFrame;
  thRect:=BoundsRect;
  OffsetRect({CurrentRect.}thRect, -ALeft, -AUp);
  BoundsRect:=thRect;
  {if FState = fsFrame then} PaintFrame;
end;

procedure TSelectedFrame.SizeFrame(ALeft, AUp, ARight, ADown : integer);
begin
  PaintFrame;
  Left := Left - ALeft;
  Top := Top - AUp;
  Width := Width +ALeft+ ARight;
  height := height +AUp+ ADown;
//  Parent.Repaint;
  PaintFrame;
end;

type
  TREpoThread = class(TThread)
  private
  protected
    procedure Execute; override;
  public
    main:TWinControl;
    onNeedData:TNotifyEvent;
//    PreviewStyle:TFormStyle; // MDIForm -   ,     INIFile
  end;

procedure TRepoThread.execute;
var i:integer;
    thRepoEdit:TRepoEdit;
begin
  if main=nil then begin
    bvMessError('    !!')
  end
  else begin
     thRepoEdit:=nil;
     for i:=0 to Main.ComponentCount-1 do
     if Main.components[i] is TRepoEdit then begin
        thRepoEdit:=(Main.Components[i] as TRepoEdit);
        break;
     end;
     if not assigned(thRepoEdit) then begin
        thRepoEdit:=TRepoEdit.Create(Main);
        thRepoEdit.Name:='TempRepoEdit';
        thRepoEdit.Loaded;
     end;
     thRepoEdit.OnNeedData:=OnNeedData;
//     thRepoEdit.PreviewStyle:=PreviewStyle;
     Synchronize(thRepoEdit.Execute);
     synchronize(main.free);
  end;
end;

procedure ExecuteReport(pMain:TWinControl;pOnNeedData:tnotifyevent=nil{;pPreviewStyle:TFormStyle=fsMDIForm}); // MDIForm -   ,     INIFile
begin
  if pmain=nil then begin
    bvMessError('    !!')
  end
  else
    with TREpoThread.Create(true) do
    try
      main:=pMain;
      onNeedData:=pOnNeedData;
      freeOnTerminate:=true;
//      PreviewStyle:=pPreviewStyle;
//      execute;
      Resume;
//      free;
    except
      on e:exception do  begin
        bvmessError('   !'+#13+
                                    ': '+e.message);
        Terminate;
      end
    end;
end;

function TaRepNameForm:TField;
begin
  if Assigned(tareport) then result:=taREport.FindField('NameForm')
  else Result:=nil;
end;

function TaRepNamecomp:tField;
begin
  if Assigned(tareport) then result:=taREport.FindField('NameComponent')
  else Result:=nil;
end;

Function TaRepValue:TMemoField;
begin
  if Assigned(tareport) then result:=taREport.FindField('Value') as TMemoField
  else Result:=nil;
end;


initialization

  TaReport:=nil;
  IniFile:=nil;

//  UnRegisterpreview

finalization
  try
  if Assigned(TaReport) then begin
    if TaReport.Active then begin
      TaReport.FlushBuffers;
      TaReport.Close;
    end;
    TaReport.Free;
  end;
  except
    on e:exception do bvMessError('     !'+#13+#13+
         ': '+e.message);
  end;
end.
